# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetQueryQuickPicksFilterResult',
    'GetQueryQuickPicksQuickPickResult',
    'GetTraceAggregatedSnapshotDataDetailResult',
    'GetTraceServiceSummaryResult',
    'GetTraceSnapshotDataTraceSnapshotDetailResult',
    'GetTraceSpanResult',
    'GetTraceSpanLogResult',
    'GetTraceSpanLogSpanLogResult',
    'GetTraceSpanSummaryResult',
    'GetTraceSpanSummaryServiceSummaryResult',
    'GetTraceSpanTagResult',
]

@pulumi.output_type
class GetQueryQuickPicksFilterResult(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str],
                 regex: Optional[bool] = None):
        GetQueryQuickPicksFilterResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            values=values,
            regex=regex,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: str,
             values: Sequence[str],
             regex: Optional[bool] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("name", name)
        _setter("values", values)
        if regex is not None:
            _setter("regex", regex)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        return pulumi.get(self, "values")

    @property
    @pulumi.getter
    def regex(self) -> Optional[bool]:
        return pulumi.get(self, "regex")


@pulumi.output_type
class GetQueryQuickPicksQuickPickResult(dict):
    def __init__(__self__, *,
                 quick_pick_name: str,
                 quick_pick_query: str):
        """
        :param str quick_pick_name: Quick Pick name for the query.
        :param str quick_pick_query: Query for the Quick Pick.
        """
        GetQueryQuickPicksQuickPickResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            quick_pick_name=quick_pick_name,
            quick_pick_query=quick_pick_query,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             quick_pick_name: str,
             quick_pick_query: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'quickPickName' in kwargs:
            quick_pick_name = kwargs['quickPickName']
        if 'quickPickQuery' in kwargs:
            quick_pick_query = kwargs['quickPickQuery']

        _setter("quick_pick_name", quick_pick_name)
        _setter("quick_pick_query", quick_pick_query)

    @property
    @pulumi.getter(name="quickPickName")
    def quick_pick_name(self) -> str:
        """
        Quick Pick name for the query.
        """
        return pulumi.get(self, "quick_pick_name")

    @property
    @pulumi.getter(name="quickPickQuery")
    def quick_pick_query(self) -> str:
        """
        Query for the Quick Pick.
        """
        return pulumi.get(self, "quick_pick_query")


@pulumi.output_type
class GetTraceAggregatedSnapshotDataDetailResult(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        """
        :param str key: Name of the property.
        :param str value: Value of the property.
        """
        GetTraceAggregatedSnapshotDataDetailResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: str,
             value: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("key", key)
        _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Name of the property.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Value of the property.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetTraceServiceSummaryResult(dict):
    def __init__(__self__, *,
                 error_spans: str,
                 span_service_name: str,
                 total_spans: str):
        """
        :param str error_spans: Number of spans with errors for serviceName in the trace.
        :param str span_service_name: Name associated with the service.
        :param str total_spans: Number of spans for serviceName in the trace.
        """
        GetTraceServiceSummaryResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            error_spans=error_spans,
            span_service_name=span_service_name,
            total_spans=total_spans,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             error_spans: str,
             span_service_name: str,
             total_spans: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'errorSpans' in kwargs:
            error_spans = kwargs['errorSpans']
        if 'spanServiceName' in kwargs:
            span_service_name = kwargs['spanServiceName']
        if 'totalSpans' in kwargs:
            total_spans = kwargs['totalSpans']

        _setter("error_spans", error_spans)
        _setter("span_service_name", span_service_name)
        _setter("total_spans", total_spans)

    @property
    @pulumi.getter(name="errorSpans")
    def error_spans(self) -> str:
        """
        Number of spans with errors for serviceName in the trace.
        """
        return pulumi.get(self, "error_spans")

    @property
    @pulumi.getter(name="spanServiceName")
    def span_service_name(self) -> str:
        """
        Name associated with the service.
        """
        return pulumi.get(self, "span_service_name")

    @property
    @pulumi.getter(name="totalSpans")
    def total_spans(self) -> str:
        """
        Number of spans for serviceName in the trace.
        """
        return pulumi.get(self, "total_spans")


@pulumi.output_type
class GetTraceSnapshotDataTraceSnapshotDetailResult(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        """
        :param str key: Name of the property.
        :param str value: Value of the property.
        """
        GetTraceSnapshotDataTraceSnapshotDetailResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: str,
             value: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("key", key)
        _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Name of the property.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Value of the property.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetTraceSpanResult(dict):
    def __init__(__self__, *,
                 duration_in_ms: str,
                 is_error: bool,
                 key: str,
                 kind: str,
                 logs: Sequence['outputs.GetTraceSpanLogResult'],
                 operation_name: str,
                 parent_span_key: str,
                 service_name: str,
                 tags: Sequence['outputs.GetTraceSpanTagResult'],
                 time_ended: str,
                 time_started: str,
                 trace_key: str):
        """
        :param str duration_in_ms: Total span duration in milliseconds.
        :param bool is_error: Indicates if the span has an error.
        :param str key: Unique identifier (spanId) for the span.  Note that this field is defined as spanKey in the API and it maps to the spanId in the trace data in Application Performance Monitoring.
        :param str kind: Kind associated with the span.
        :param Sequence['GetTraceSpanLogArgs'] logs: List of logs associated with the span.
        :param str operation_name: Span name associated with the trace.  This is usually the method or URI of the request.
        :param str parent_span_key: Unique parent identifier for the span if one exists. For root spans this will be null.
        :param str service_name: Service name associated with the span.
        :param Sequence['GetTraceSpanTagArgs'] tags: List of tags associated with the span.
        :param str time_ended: Span end time.  Timestamp when the span was completed.
        :param str time_started: Span start time.  Timestamp when the span was started.
        :param str trace_key: Unique Application Performance Monitoring trace identifier (traceId).
        """
        GetTraceSpanResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            duration_in_ms=duration_in_ms,
            is_error=is_error,
            key=key,
            kind=kind,
            logs=logs,
            operation_name=operation_name,
            parent_span_key=parent_span_key,
            service_name=service_name,
            tags=tags,
            time_ended=time_ended,
            time_started=time_started,
            trace_key=trace_key,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             duration_in_ms: str,
             is_error: bool,
             key: str,
             kind: str,
             logs: Sequence['outputs.GetTraceSpanLogResult'],
             operation_name: str,
             parent_span_key: str,
             service_name: str,
             tags: Sequence['outputs.GetTraceSpanTagResult'],
             time_ended: str,
             time_started: str,
             trace_key: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'durationInMs' in kwargs:
            duration_in_ms = kwargs['durationInMs']
        if 'isError' in kwargs:
            is_error = kwargs['isError']
        if 'operationName' in kwargs:
            operation_name = kwargs['operationName']
        if 'parentSpanKey' in kwargs:
            parent_span_key = kwargs['parentSpanKey']
        if 'serviceName' in kwargs:
            service_name = kwargs['serviceName']
        if 'timeEnded' in kwargs:
            time_ended = kwargs['timeEnded']
        if 'timeStarted' in kwargs:
            time_started = kwargs['timeStarted']
        if 'traceKey' in kwargs:
            trace_key = kwargs['traceKey']

        _setter("duration_in_ms", duration_in_ms)
        _setter("is_error", is_error)
        _setter("key", key)
        _setter("kind", kind)
        _setter("logs", logs)
        _setter("operation_name", operation_name)
        _setter("parent_span_key", parent_span_key)
        _setter("service_name", service_name)
        _setter("tags", tags)
        _setter("time_ended", time_ended)
        _setter("time_started", time_started)
        _setter("trace_key", trace_key)

    @property
    @pulumi.getter(name="durationInMs")
    def duration_in_ms(self) -> str:
        """
        Total span duration in milliseconds.
        """
        return pulumi.get(self, "duration_in_ms")

    @property
    @pulumi.getter(name="isError")
    def is_error(self) -> bool:
        """
        Indicates if the span has an error.
        """
        return pulumi.get(self, "is_error")

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Unique identifier (spanId) for the span.  Note that this field is defined as spanKey in the API and it maps to the spanId in the trace data in Application Performance Monitoring.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def kind(self) -> str:
        """
        Kind associated with the span.
        """
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def logs(self) -> Sequence['outputs.GetTraceSpanLogResult']:
        """
        List of logs associated with the span.
        """
        return pulumi.get(self, "logs")

    @property
    @pulumi.getter(name="operationName")
    def operation_name(self) -> str:
        """
        Span name associated with the trace.  This is usually the method or URI of the request.
        """
        return pulumi.get(self, "operation_name")

    @property
    @pulumi.getter(name="parentSpanKey")
    def parent_span_key(self) -> str:
        """
        Unique parent identifier for the span if one exists. For root spans this will be null.
        """
        return pulumi.get(self, "parent_span_key")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> str:
        """
        Service name associated with the span.
        """
        return pulumi.get(self, "service_name")

    @property
    @pulumi.getter
    def tags(self) -> Sequence['outputs.GetTraceSpanTagResult']:
        """
        List of tags associated with the span.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="timeEnded")
    def time_ended(self) -> str:
        """
        Span end time.  Timestamp when the span was completed.
        """
        return pulumi.get(self, "time_ended")

    @property
    @pulumi.getter(name="timeStarted")
    def time_started(self) -> str:
        """
        Span start time.  Timestamp when the span was started.
        """
        return pulumi.get(self, "time_started")

    @property
    @pulumi.getter(name="traceKey")
    def trace_key(self) -> str:
        """
        Unique Application Performance Monitoring trace identifier (traceId).
        """
        return pulumi.get(self, "trace_key")


@pulumi.output_type
class GetTraceSpanLogResult(dict):
    def __init__(__self__, *,
                 span_logs: Sequence['outputs.GetTraceSpanLogSpanLogResult'],
                 time_created: str):
        """
        :param Sequence['GetTraceSpanLogSpanLogArgs'] span_logs: List of logs associated with the span at the given timestamp.
        :param str time_created: Timestamp at which the log is created.
        """
        GetTraceSpanLogResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            span_logs=span_logs,
            time_created=time_created,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             span_logs: Sequence['outputs.GetTraceSpanLogSpanLogResult'],
             time_created: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'spanLogs' in kwargs:
            span_logs = kwargs['spanLogs']
        if 'timeCreated' in kwargs:
            time_created = kwargs['timeCreated']

        _setter("span_logs", span_logs)
        _setter("time_created", time_created)

    @property
    @pulumi.getter(name="spanLogs")
    def span_logs(self) -> Sequence['outputs.GetTraceSpanLogSpanLogResult']:
        """
        List of logs associated with the span at the given timestamp.
        """
        return pulumi.get(self, "span_logs")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> str:
        """
        Timestamp at which the log is created.
        """
        return pulumi.get(self, "time_created")


@pulumi.output_type
class GetTraceSpanLogSpanLogResult(dict):
    def __init__(__self__, *,
                 log_key: str,
                 log_value: str):
        """
        :param str log_key: Key that specifies the log name.
        :param str log_value: Value associated with the log key.
        """
        GetTraceSpanLogSpanLogResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            log_key=log_key,
            log_value=log_value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             log_key: str,
             log_value: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'logKey' in kwargs:
            log_key = kwargs['logKey']
        if 'logValue' in kwargs:
            log_value = kwargs['logValue']

        _setter("log_key", log_key)
        _setter("log_value", log_value)

    @property
    @pulumi.getter(name="logKey")
    def log_key(self) -> str:
        """
        Key that specifies the log name.
        """
        return pulumi.get(self, "log_key")

    @property
    @pulumi.getter(name="logValue")
    def log_value(self) -> str:
        """
        Value associated with the log key.
        """
        return pulumi.get(self, "log_value")


@pulumi.output_type
class GetTraceSpanSummaryResult(dict):
    def __init__(__self__, *,
                 error_span_count: int,
                 is_fault: bool,
                 key: str,
                 root_span_duration_in_ms: int,
                 root_span_operation_name: str,
                 root_span_service_name: str,
                 service_summaries: Sequence['outputs.GetTraceSpanSummaryServiceSummaryResult'],
                 span_count: int,
                 time_earliest_span_started: str,
                 time_latest_span_ended: str,
                 time_root_span_ended: str,
                 time_root_span_started: str,
                 trace_duration_in_ms: int,
                 trace_error_code: str,
                 trace_error_type: str,
                 trace_status: str):
        """
        :param int error_span_count: The number of spans with errors that have been processed by the system for the trace. Note that the number of spans with errors will be less than or equal to the total number of spans in the trace.
        :param bool is_fault: Boolean flag that indicates whether the trace has an error.
        :param str key: Unique identifier (spanId) for the span.  Note that this field is defined as spanKey in the API and it maps to the spanId in the trace data in Application Performance Monitoring.
        :param int root_span_duration_in_ms: Time taken for the root span operation to complete in milliseconds.
        :param str root_span_operation_name: Root span name associated with the trace. This is the flow start operation name. Null is displayed if the root span is not yet completed.
        :param str root_span_service_name: Service associated with the trace.
        :param Sequence['GetTraceSpanSummaryServiceSummaryArgs'] service_summaries: A summary of the spans by service.
        :param int span_count: The number of spans that have been processed by the system for the trace.  Note that there could be additional spans that have not been processed or reported yet if the trace is still in progress.
        :param str time_earliest_span_started: Start time of the earliest span in the span collection.
        :param str time_latest_span_ended: End time of the span that most recently ended in the span collection.
        :param str time_root_span_ended: End time of the root span for the span collection.
        :param str time_root_span_started: Start time of the root span for the span collection.
        :param int trace_duration_in_ms: Time between the start of the earliest span and the end of the most recent span in milliseconds.
        :param str trace_error_code: Error code of the trace.
        :param str trace_error_type: Error type of the trace.
        :param str trace_status: The status of the trace. The trace statuses are defined as follows: complete - a root span has been recorded, but there is no information on the errors. success - a complete root span is recorded there is a successful error type and error code - HTTP 200. incomplete - the root span has not yet been received. error - the root span returned with an error. There may or may not be an associated error code or error type.
        """
        GetTraceSpanSummaryResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            error_span_count=error_span_count,
            is_fault=is_fault,
            key=key,
            root_span_duration_in_ms=root_span_duration_in_ms,
            root_span_operation_name=root_span_operation_name,
            root_span_service_name=root_span_service_name,
            service_summaries=service_summaries,
            span_count=span_count,
            time_earliest_span_started=time_earliest_span_started,
            time_latest_span_ended=time_latest_span_ended,
            time_root_span_ended=time_root_span_ended,
            time_root_span_started=time_root_span_started,
            trace_duration_in_ms=trace_duration_in_ms,
            trace_error_code=trace_error_code,
            trace_error_type=trace_error_type,
            trace_status=trace_status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             error_span_count: int,
             is_fault: bool,
             key: str,
             root_span_duration_in_ms: int,
             root_span_operation_name: str,
             root_span_service_name: str,
             service_summaries: Sequence['outputs.GetTraceSpanSummaryServiceSummaryResult'],
             span_count: int,
             time_earliest_span_started: str,
             time_latest_span_ended: str,
             time_root_span_ended: str,
             time_root_span_started: str,
             trace_duration_in_ms: int,
             trace_error_code: str,
             trace_error_type: str,
             trace_status: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'errorSpanCount' in kwargs:
            error_span_count = kwargs['errorSpanCount']
        if 'isFault' in kwargs:
            is_fault = kwargs['isFault']
        if 'rootSpanDurationInMs' in kwargs:
            root_span_duration_in_ms = kwargs['rootSpanDurationInMs']
        if 'rootSpanOperationName' in kwargs:
            root_span_operation_name = kwargs['rootSpanOperationName']
        if 'rootSpanServiceName' in kwargs:
            root_span_service_name = kwargs['rootSpanServiceName']
        if 'serviceSummaries' in kwargs:
            service_summaries = kwargs['serviceSummaries']
        if 'spanCount' in kwargs:
            span_count = kwargs['spanCount']
        if 'timeEarliestSpanStarted' in kwargs:
            time_earliest_span_started = kwargs['timeEarliestSpanStarted']
        if 'timeLatestSpanEnded' in kwargs:
            time_latest_span_ended = kwargs['timeLatestSpanEnded']
        if 'timeRootSpanEnded' in kwargs:
            time_root_span_ended = kwargs['timeRootSpanEnded']
        if 'timeRootSpanStarted' in kwargs:
            time_root_span_started = kwargs['timeRootSpanStarted']
        if 'traceDurationInMs' in kwargs:
            trace_duration_in_ms = kwargs['traceDurationInMs']
        if 'traceErrorCode' in kwargs:
            trace_error_code = kwargs['traceErrorCode']
        if 'traceErrorType' in kwargs:
            trace_error_type = kwargs['traceErrorType']
        if 'traceStatus' in kwargs:
            trace_status = kwargs['traceStatus']

        _setter("error_span_count", error_span_count)
        _setter("is_fault", is_fault)
        _setter("key", key)
        _setter("root_span_duration_in_ms", root_span_duration_in_ms)
        _setter("root_span_operation_name", root_span_operation_name)
        _setter("root_span_service_name", root_span_service_name)
        _setter("service_summaries", service_summaries)
        _setter("span_count", span_count)
        _setter("time_earliest_span_started", time_earliest_span_started)
        _setter("time_latest_span_ended", time_latest_span_ended)
        _setter("time_root_span_ended", time_root_span_ended)
        _setter("time_root_span_started", time_root_span_started)
        _setter("trace_duration_in_ms", trace_duration_in_ms)
        _setter("trace_error_code", trace_error_code)
        _setter("trace_error_type", trace_error_type)
        _setter("trace_status", trace_status)

    @property
    @pulumi.getter(name="errorSpanCount")
    def error_span_count(self) -> int:
        """
        The number of spans with errors that have been processed by the system for the trace. Note that the number of spans with errors will be less than or equal to the total number of spans in the trace.
        """
        return pulumi.get(self, "error_span_count")

    @property
    @pulumi.getter(name="isFault")
    def is_fault(self) -> bool:
        """
        Boolean flag that indicates whether the trace has an error.
        """
        return pulumi.get(self, "is_fault")

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Unique identifier (spanId) for the span.  Note that this field is defined as spanKey in the API and it maps to the spanId in the trace data in Application Performance Monitoring.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter(name="rootSpanDurationInMs")
    def root_span_duration_in_ms(self) -> int:
        """
        Time taken for the root span operation to complete in milliseconds.
        """
        return pulumi.get(self, "root_span_duration_in_ms")

    @property
    @pulumi.getter(name="rootSpanOperationName")
    def root_span_operation_name(self) -> str:
        """
        Root span name associated with the trace. This is the flow start operation name. Null is displayed if the root span is not yet completed.
        """
        return pulumi.get(self, "root_span_operation_name")

    @property
    @pulumi.getter(name="rootSpanServiceName")
    def root_span_service_name(self) -> str:
        """
        Service associated with the trace.
        """
        return pulumi.get(self, "root_span_service_name")

    @property
    @pulumi.getter(name="serviceSummaries")
    def service_summaries(self) -> Sequence['outputs.GetTraceSpanSummaryServiceSummaryResult']:
        """
        A summary of the spans by service.
        """
        return pulumi.get(self, "service_summaries")

    @property
    @pulumi.getter(name="spanCount")
    def span_count(self) -> int:
        """
        The number of spans that have been processed by the system for the trace.  Note that there could be additional spans that have not been processed or reported yet if the trace is still in progress.
        """
        return pulumi.get(self, "span_count")

    @property
    @pulumi.getter(name="timeEarliestSpanStarted")
    def time_earliest_span_started(self) -> str:
        """
        Start time of the earliest span in the span collection.
        """
        return pulumi.get(self, "time_earliest_span_started")

    @property
    @pulumi.getter(name="timeLatestSpanEnded")
    def time_latest_span_ended(self) -> str:
        """
        End time of the span that most recently ended in the span collection.
        """
        return pulumi.get(self, "time_latest_span_ended")

    @property
    @pulumi.getter(name="timeRootSpanEnded")
    def time_root_span_ended(self) -> str:
        """
        End time of the root span for the span collection.
        """
        return pulumi.get(self, "time_root_span_ended")

    @property
    @pulumi.getter(name="timeRootSpanStarted")
    def time_root_span_started(self) -> str:
        """
        Start time of the root span for the span collection.
        """
        return pulumi.get(self, "time_root_span_started")

    @property
    @pulumi.getter(name="traceDurationInMs")
    def trace_duration_in_ms(self) -> int:
        """
        Time between the start of the earliest span and the end of the most recent span in milliseconds.
        """
        return pulumi.get(self, "trace_duration_in_ms")

    @property
    @pulumi.getter(name="traceErrorCode")
    def trace_error_code(self) -> str:
        """
        Error code of the trace.
        """
        return pulumi.get(self, "trace_error_code")

    @property
    @pulumi.getter(name="traceErrorType")
    def trace_error_type(self) -> str:
        """
        Error type of the trace.
        """
        return pulumi.get(self, "trace_error_type")

    @property
    @pulumi.getter(name="traceStatus")
    def trace_status(self) -> str:
        """
        The status of the trace. The trace statuses are defined as follows: complete - a root span has been recorded, but there is no information on the errors. success - a complete root span is recorded there is a successful error type and error code - HTTP 200. incomplete - the root span has not yet been received. error - the root span returned with an error. There may or may not be an associated error code or error type.
        """
        return pulumi.get(self, "trace_status")


@pulumi.output_type
class GetTraceSpanSummaryServiceSummaryResult(dict):
    def __init__(__self__, *,
                 error_spans: str,
                 span_service_name: str,
                 total_spans: str):
        """
        :param str error_spans: Number of spans with errors for serviceName in the trace.
        :param str span_service_name: Name associated with the service.
        :param str total_spans: Number of spans for serviceName in the trace.
        """
        GetTraceSpanSummaryServiceSummaryResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            error_spans=error_spans,
            span_service_name=span_service_name,
            total_spans=total_spans,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             error_spans: str,
             span_service_name: str,
             total_spans: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'errorSpans' in kwargs:
            error_spans = kwargs['errorSpans']
        if 'spanServiceName' in kwargs:
            span_service_name = kwargs['spanServiceName']
        if 'totalSpans' in kwargs:
            total_spans = kwargs['totalSpans']

        _setter("error_spans", error_spans)
        _setter("span_service_name", span_service_name)
        _setter("total_spans", total_spans)

    @property
    @pulumi.getter(name="errorSpans")
    def error_spans(self) -> str:
        """
        Number of spans with errors for serviceName in the trace.
        """
        return pulumi.get(self, "error_spans")

    @property
    @pulumi.getter(name="spanServiceName")
    def span_service_name(self) -> str:
        """
        Name associated with the service.
        """
        return pulumi.get(self, "span_service_name")

    @property
    @pulumi.getter(name="totalSpans")
    def total_spans(self) -> str:
        """
        Number of spans for serviceName in the trace.
        """
        return pulumi.get(self, "total_spans")


@pulumi.output_type
class GetTraceSpanTagResult(dict):
    def __init__(__self__, *,
                 tag_name: str,
                 tag_value: str):
        """
        :param str tag_name: Key that specifies the tag name.
        :param str tag_value: Value associated with the tag key.
        """
        GetTraceSpanTagResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            tag_name=tag_name,
            tag_value=tag_value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             tag_name: str,
             tag_value: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'tagName' in kwargs:
            tag_name = kwargs['tagName']
        if 'tagValue' in kwargs:
            tag_value = kwargs['tagValue']

        _setter("tag_name", tag_name)
        _setter("tag_value", tag_value)

    @property
    @pulumi.getter(name="tagName")
    def tag_name(self) -> str:
        """
        Key that specifies the tag name.
        """
        return pulumi.get(self, "tag_name")

    @property
    @pulumi.getter(name="tagValue")
    def tag_value(self) -> str:
        """
        Value associated with the tag key.
        """
        return pulumi.get(self, "tag_value")


