# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InstanceConfigurationArgs', 'InstanceConfiguration']

@pulumi.input_type
class InstanceConfigurationArgs:
    def __init__(__self__, *,
                 compartment_id: pulumi.Input[str],
                 defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 instance_details: Optional[pulumi.Input['InstanceConfigurationInstanceDetailsArgs']] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a InstanceConfiguration resource.
        :param pulumi.Input[str] compartment_id: (Updatable) The OCID of the compartment containing images to search
        :param pulumi.Input[Mapping[str, Any]] defined_tags: Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param pulumi.Input[str] display_name: A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        :param pulumi.Input[Mapping[str, Any]] freeform_tags: Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        :param pulumi.Input[str] instance_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the instance to use to create the instance configuration.
        :param pulumi.Input[str] source: The source of the instance configuration. An instance configuration defines the settings to use when creating Compute instances, including details such as the base image, shape, and metadata. You can also specify the associated resources for the instance, such as block volume attachments and network configuration.
               
               When you create an instance configuration using an existing instance as a template, the instance configuration does not include any information from the source instance's boot volume, such as installed applications, binaries, and files on the instance. It also does not include the contents of any block volumes that are attached to the instance.
               
               To create an instance configuration that includes the custom setup from an instance's boot volume, you must first create a custom image from the instance (see [CreateImage](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Image/CreateImage)). Then, use the custom image to launch a new instance (see [LaunchInstance](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstance)). Finally, create the instance configuration based on the instance that you created from the custom image.
               
               To include block volume contents with an instance configuration, first create a backup of the attached block volumes (see [CreateVolumeBackup](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/VolumeBackup/CreateVolumeBackup)). Then, create the instance configuration by specifying the list of settings, using [InstanceConfigurationVolumeSourceFromVolumeBackupDetails](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/datatypes/InstanceConfigurationVolumeSourceFromVolumeBackupDetails) to include the block volume backups in the list of settings.
               
               The following values are supported:
        """
        InstanceConfigurationArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            compartment_id=compartment_id,
            defined_tags=defined_tags,
            display_name=display_name,
            freeform_tags=freeform_tags,
            instance_details=instance_details,
            instance_id=instance_id,
            source=source,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             compartment_id: pulumi.Input[str],
             defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
             display_name: Optional[pulumi.Input[str]] = None,
             freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
             instance_details: Optional[pulumi.Input['InstanceConfigurationInstanceDetailsArgs']] = None,
             instance_id: Optional[pulumi.Input[str]] = None,
             source: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'compartmentId' in kwargs:
            compartment_id = kwargs['compartmentId']
        if 'definedTags' in kwargs:
            defined_tags = kwargs['definedTags']
        if 'displayName' in kwargs:
            display_name = kwargs['displayName']
        if 'freeformTags' in kwargs:
            freeform_tags = kwargs['freeformTags']
        if 'instanceDetails' in kwargs:
            instance_details = kwargs['instanceDetails']
        if 'instanceId' in kwargs:
            instance_id = kwargs['instanceId']

        _setter("compartment_id", compartment_id)
        if defined_tags is not None:
            _setter("defined_tags", defined_tags)
        if display_name is not None:
            _setter("display_name", display_name)
        if freeform_tags is not None:
            _setter("freeform_tags", freeform_tags)
        if instance_details is not None:
            _setter("instance_details", instance_details)
        if instance_id is not None:
            _setter("instance_id", instance_id)
        if source is not None:
            _setter("source", source)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> pulumi.Input[str]:
        """
        (Updatable) The OCID of the compartment containing images to search
        """
        return pulumi.get(self, "compartment_id")

    @compartment_id.setter
    def compartment_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "compartment_id", value)

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @defined_tags.setter
    def defined_tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "defined_tags", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[str]]:
        """
        A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @freeform_tags.setter
    def freeform_tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "freeform_tags", value)

    @property
    @pulumi.getter(name="instanceDetails")
    def instance_details(self) -> Optional[pulumi.Input['InstanceConfigurationInstanceDetailsArgs']]:
        return pulumi.get(self, "instance_details")

    @instance_details.setter
    def instance_details(self, value: Optional[pulumi.Input['InstanceConfigurationInstanceDetailsArgs']]):
        pulumi.set(self, "instance_details", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the instance to use to create the instance configuration.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def source(self) -> Optional[pulumi.Input[str]]:
        """
        The source of the instance configuration. An instance configuration defines the settings to use when creating Compute instances, including details such as the base image, shape, and metadata. You can also specify the associated resources for the instance, such as block volume attachments and network configuration.

        When you create an instance configuration using an existing instance as a template, the instance configuration does not include any information from the source instance's boot volume, such as installed applications, binaries, and files on the instance. It also does not include the contents of any block volumes that are attached to the instance.

        To create an instance configuration that includes the custom setup from an instance's boot volume, you must first create a custom image from the instance (see [CreateImage](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Image/CreateImage)). Then, use the custom image to launch a new instance (see [LaunchInstance](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstance)). Finally, create the instance configuration based on the instance that you created from the custom image.

        To include block volume contents with an instance configuration, first create a backup of the attached block volumes (see [CreateVolumeBackup](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/VolumeBackup/CreateVolumeBackup)). Then, create the instance configuration by specifying the list of settings, using [InstanceConfigurationVolumeSourceFromVolumeBackupDetails](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/datatypes/InstanceConfigurationVolumeSourceFromVolumeBackupDetails) to include the block volume backups in the list of settings.

        The following values are supported:
        """
        return pulumi.get(self, "source")

    @source.setter
    def source(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source", value)


@pulumi.input_type
class _InstanceConfigurationState:
    def __init__(__self__, *,
                 compartment_id: Optional[pulumi.Input[str]] = None,
                 deferred_fields: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 instance_details: Optional[pulumi.Input['InstanceConfigurationInstanceDetailsArgs']] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[str]] = None,
                 time_created: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering InstanceConfiguration resources.
        :param pulumi.Input[str] compartment_id: (Updatable) The OCID of the compartment containing images to search
        :param pulumi.Input[Sequence[pulumi.Input[str]]] deferred_fields: Parameters that were not specified when the instance configuration was created, but that are required to launch an instance from the instance configuration. See the [LaunchInstanceConfiguration](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstanceConfiguration) operation.
        :param pulumi.Input[Mapping[str, Any]] defined_tags: Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param pulumi.Input[str] display_name: A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        :param pulumi.Input[Mapping[str, Any]] freeform_tags: Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        :param pulumi.Input[str] instance_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the instance to use to create the instance configuration.
        :param pulumi.Input[str] source: The source of the instance configuration. An instance configuration defines the settings to use when creating Compute instances, including details such as the base image, shape, and metadata. You can also specify the associated resources for the instance, such as block volume attachments and network configuration.
               
               When you create an instance configuration using an existing instance as a template, the instance configuration does not include any information from the source instance's boot volume, such as installed applications, binaries, and files on the instance. It also does not include the contents of any block volumes that are attached to the instance.
               
               To create an instance configuration that includes the custom setup from an instance's boot volume, you must first create a custom image from the instance (see [CreateImage](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Image/CreateImage)). Then, use the custom image to launch a new instance (see [LaunchInstance](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstance)). Finally, create the instance configuration based on the instance that you created from the custom image.
               
               To include block volume contents with an instance configuration, first create a backup of the attached block volumes (see [CreateVolumeBackup](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/VolumeBackup/CreateVolumeBackup)). Then, create the instance configuration by specifying the list of settings, using [InstanceConfigurationVolumeSourceFromVolumeBackupDetails](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/datatypes/InstanceConfigurationVolumeSourceFromVolumeBackupDetails) to include the block volume backups in the list of settings.
               
               The following values are supported:
        :param pulumi.Input[str] time_created: The date and time the instance configuration was created, in the format defined by [RFC3339](https://tools.ietf.org/html/rfc3339).  Example: `2016-08-25T21:10:29.600Z`
        """
        _InstanceConfigurationState._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            compartment_id=compartment_id,
            deferred_fields=deferred_fields,
            defined_tags=defined_tags,
            display_name=display_name,
            freeform_tags=freeform_tags,
            instance_details=instance_details,
            instance_id=instance_id,
            source=source,
            time_created=time_created,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             compartment_id: Optional[pulumi.Input[str]] = None,
             deferred_fields: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
             display_name: Optional[pulumi.Input[str]] = None,
             freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
             instance_details: Optional[pulumi.Input['InstanceConfigurationInstanceDetailsArgs']] = None,
             instance_id: Optional[pulumi.Input[str]] = None,
             source: Optional[pulumi.Input[str]] = None,
             time_created: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'compartmentId' in kwargs:
            compartment_id = kwargs['compartmentId']
        if 'deferredFields' in kwargs:
            deferred_fields = kwargs['deferredFields']
        if 'definedTags' in kwargs:
            defined_tags = kwargs['definedTags']
        if 'displayName' in kwargs:
            display_name = kwargs['displayName']
        if 'freeformTags' in kwargs:
            freeform_tags = kwargs['freeformTags']
        if 'instanceDetails' in kwargs:
            instance_details = kwargs['instanceDetails']
        if 'instanceId' in kwargs:
            instance_id = kwargs['instanceId']
        if 'timeCreated' in kwargs:
            time_created = kwargs['timeCreated']

        if compartment_id is not None:
            _setter("compartment_id", compartment_id)
        if deferred_fields is not None:
            _setter("deferred_fields", deferred_fields)
        if defined_tags is not None:
            _setter("defined_tags", defined_tags)
        if display_name is not None:
            _setter("display_name", display_name)
        if freeform_tags is not None:
            _setter("freeform_tags", freeform_tags)
        if instance_details is not None:
            _setter("instance_details", instance_details)
        if instance_id is not None:
            _setter("instance_id", instance_id)
        if source is not None:
            _setter("source", source)
        if time_created is not None:
            _setter("time_created", time_created)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> Optional[pulumi.Input[str]]:
        """
        (Updatable) The OCID of the compartment containing images to search
        """
        return pulumi.get(self, "compartment_id")

    @compartment_id.setter
    def compartment_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "compartment_id", value)

    @property
    @pulumi.getter(name="deferredFields")
    def deferred_fields(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Parameters that were not specified when the instance configuration was created, but that are required to launch an instance from the instance configuration. See the [LaunchInstanceConfiguration](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstanceConfiguration) operation.
        """
        return pulumi.get(self, "deferred_fields")

    @deferred_fields.setter
    def deferred_fields(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "deferred_fields", value)

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @defined_tags.setter
    def defined_tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "defined_tags", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[str]]:
        """
        A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @freeform_tags.setter
    def freeform_tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "freeform_tags", value)

    @property
    @pulumi.getter(name="instanceDetails")
    def instance_details(self) -> Optional[pulumi.Input['InstanceConfigurationInstanceDetailsArgs']]:
        return pulumi.get(self, "instance_details")

    @instance_details.setter
    def instance_details(self, value: Optional[pulumi.Input['InstanceConfigurationInstanceDetailsArgs']]):
        pulumi.set(self, "instance_details", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the instance to use to create the instance configuration.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def source(self) -> Optional[pulumi.Input[str]]:
        """
        The source of the instance configuration. An instance configuration defines the settings to use when creating Compute instances, including details such as the base image, shape, and metadata. You can also specify the associated resources for the instance, such as block volume attachments and network configuration.

        When you create an instance configuration using an existing instance as a template, the instance configuration does not include any information from the source instance's boot volume, such as installed applications, binaries, and files on the instance. It also does not include the contents of any block volumes that are attached to the instance.

        To create an instance configuration that includes the custom setup from an instance's boot volume, you must first create a custom image from the instance (see [CreateImage](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Image/CreateImage)). Then, use the custom image to launch a new instance (see [LaunchInstance](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstance)). Finally, create the instance configuration based on the instance that you created from the custom image.

        To include block volume contents with an instance configuration, first create a backup of the attached block volumes (see [CreateVolumeBackup](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/VolumeBackup/CreateVolumeBackup)). Then, create the instance configuration by specifying the list of settings, using [InstanceConfigurationVolumeSourceFromVolumeBackupDetails](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/datatypes/InstanceConfigurationVolumeSourceFromVolumeBackupDetails) to include the block volume backups in the list of settings.

        The following values are supported:
        """
        return pulumi.get(self, "source")

    @source.setter
    def source(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source", value)

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> Optional[pulumi.Input[str]]:
        """
        The date and time the instance configuration was created, in the format defined by [RFC3339](https://tools.ietf.org/html/rfc3339).  Example: `2016-08-25T21:10:29.600Z`
        """
        return pulumi.get(self, "time_created")

    @time_created.setter
    def time_created(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "time_created", value)


class InstanceConfiguration(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 compartment_id: Optional[pulumi.Input[str]] = None,
                 defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 instance_details: Optional[pulumi.Input[pulumi.InputType['InstanceConfigurationInstanceDetailsArgs']]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource provides the Instance Configuration resource in Oracle Cloud Infrastructure Core service.

        Creates an instance configuration. An instance configuration is a template that defines the
        settings to use when creating Compute instances.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_instance_configuration = oci.core.InstanceConfiguration("testInstanceConfiguration",
            compartment_id=var["compartment_id"],
            defined_tags={
                "Operations.CostCenter": "42",
            },
            display_name=var["instance_configuration_display_name"],
            freeform_tags={
                "Department": "Finance",
            },
            instance_details=oci.core.InstanceConfigurationInstanceDetailsArgs(
                instance_type=var["instance_configuration_instance_details_instance_type"],
                block_volumes=[oci.core.InstanceConfigurationInstanceDetailsBlockVolumeArgs(
                    attach_details=oci.core.InstanceConfigurationInstanceDetailsBlockVolumeAttachDetailsArgs(
                        type=var["instance_configuration_instance_details_block_volumes_attach_details_type"],
                        device=var["instance_configuration_instance_details_block_volumes_attach_details_device"],
                        display_name=var["instance_configuration_instance_details_block_volumes_attach_details_display_name"],
                        is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_block_volumes_attach_details_is_pv_encryption_in_transit_enabled"],
                        is_read_only=var["instance_configuration_instance_details_block_volumes_attach_details_is_read_only"],
                        is_shareable=var["instance_configuration_instance_details_block_volumes_attach_details_is_shareable"],
                        use_chap=var["instance_configuration_instance_details_block_volumes_attach_details_use_chap"],
                    ),
                    create_details=oci.core.InstanceConfigurationInstanceDetailsBlockVolumeCreateDetailsArgs(
                        autotune_policies=[oci.core.InstanceConfigurationInstanceDetailsBlockVolumeCreateDetailsAutotunePolicyArgs(
                            autotune_type=var["instance_configuration_instance_details_block_volumes_create_details_autotune_policies_autotune_type"],
                            max_vpus_per_gb=var["instance_configuration_instance_details_block_volumes_create_details_autotune_policies_max_vpus_per_gb"],
                        )],
                        availability_domain=var["instance_configuration_instance_details_block_volumes_create_details_availability_domain"],
                        backup_policy_id=data["oci_core_volume_backup_policies"]["test_volume_backup_policies"]["volume_backup_policies"][0]["id"],
                        block_volume_replicas=oci.core.InstanceConfigurationInstanceDetailsBlockVolumeCreateDetailsBlockVolumeReplicasArgs(
                            availability_domain=var["instance_configuration_instance_details_block_volumes_create_details_block_volume_replicas_availability_domain"],
                            display_name=var["instance_configuration_instance_details_block_volumes_create_details_block_volume_replicas_display_name"],
                        ),
                        compartment_id=var["compartment_id"],
                        defined_tags={
                            "Operations.CostCenter": "42",
                        },
                        display_name=var["instance_configuration_instance_details_block_volumes_create_details_display_name"],
                        freeform_tags={
                            "Department": "Finance",
                        },
                        is_auto_tune_enabled=var["instance_configuration_instance_details_block_volumes_create_details_is_auto_tune_enabled"],
                        kms_key_id=oci_kms_key["test_key"]["id"],
                        size_in_gbs=var["instance_configuration_instance_details_block_volumes_create_details_size_in_gbs"],
                        source_details=oci.core.InstanceConfigurationInstanceDetailsBlockVolumeCreateDetailsSourceDetailsArgs(
                            type=var["instance_configuration_instance_details_block_volumes_create_details_source_details_type"],
                            id=var["instance_configuration_instance_details_block_volumes_create_details_source_details_id"],
                        ),
                        vpus_per_gb=var["instance_configuration_instance_details_block_volumes_create_details_vpus_per_gb"],
                    ),
                    volume_id=oci_core_volume["test_volume"]["id"],
                )],
                launch_details=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsArgs(
                    agent_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsAgentConfigArgs(
                        are_all_plugins_disabled=var["instance_configuration_instance_details_launch_details_agent_config_are_all_plugins_disabled"],
                        is_management_disabled=var["instance_configuration_instance_details_launch_details_agent_config_is_management_disabled"],
                        is_monitoring_disabled=var["instance_configuration_instance_details_launch_details_agent_config_is_monitoring_disabled"],
                        plugins_configs=[oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsAgentConfigPluginsConfigArgs(
                            desired_state=var["instance_configuration_instance_details_launch_details_agent_config_plugins_config_desired_state"],
                            name=var["instance_configuration_instance_details_launch_details_agent_config_plugins_config_name"],
                        )],
                    ),
                    availability_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsAvailabilityConfigArgs(
                        is_live_migration_preferred=var["instance_configuration_instance_details_launch_details_availability_config_is_live_migration_preferred"],
                        recovery_action=var["instance_configuration_instance_details_launch_details_availability_config_recovery_action"],
                    ),
                    availability_domain=var["instance_configuration_instance_details_launch_details_availability_domain"],
                    capacity_reservation_id=oci_core_capacity_reservation["test_capacity_reservation"]["id"],
                    compartment_id=var["compartment_id"],
                    create_vnic_details=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsCreateVnicDetailsArgs(
                        assign_ipv6ip=var["instance_configuration_instance_details_launch_details_create_vnic_details_assign_ipv6ip"],
                        assign_private_dns_record=var["instance_configuration_instance_details_launch_details_create_vnic_details_assign_private_dns_record"],
                        assign_public_ip=var["instance_configuration_instance_details_launch_details_create_vnic_details_assign_public_ip"],
                        defined_tags={
                            "Operations.CostCenter": "42",
                        },
                        display_name=var["instance_configuration_instance_details_launch_details_create_vnic_details_display_name"],
                        freeform_tags={
                            "Department": "Finance",
                        },
                        hostname_label=var["instance_configuration_instance_details_launch_details_create_vnic_details_hostname_label"],
                        ipv6address_ipv6subnet_cidr_pair_details=[oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsCreateVnicDetailsIpv6addressIpv6subnetCidrPairDetailArgs(
                            ipv6address=var["instance_configuration_instance_details_launch_details_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6address"],
                            ipv6subnet_cidr=var["instance_configuration_instance_details_launch_details_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6subnet_cidr"],
                        )],
                        nsg_ids=var["instance_configuration_instance_details_launch_details_create_vnic_details_nsg_ids"],
                        private_ip=var["instance_configuration_instance_details_launch_details_create_vnic_details_private_ip"],
                        skip_source_dest_check=var["instance_configuration_instance_details_launch_details_create_vnic_details_skip_source_dest_check"],
                        subnet_id=oci_core_subnet["test_subnet"]["id"],
                    ),
                    dedicated_vm_host_id=oci_core_dedicated_vm_host["test_dedicated_vm_host"]["id"],
                    defined_tags={
                        "Operations.CostCenter": "42",
                    },
                    display_name=var["instance_configuration_instance_details_launch_details_display_name"],
                    extended_metadata=var["instance_configuration_instance_details_launch_details_extended_metadata"],
                    fault_domain=var["instance_configuration_instance_details_launch_details_fault_domain"],
                    freeform_tags={
                        "Department": "Finance",
                    },
                    instance_options=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsInstanceOptionsArgs(
                        are_legacy_imds_endpoints_disabled=var["instance_configuration_instance_details_launch_details_instance_options_are_legacy_imds_endpoints_disabled"],
                    ),
                    ipxe_script=var["instance_configuration_instance_details_launch_details_ipxe_script"],
                    is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_launch_details_is_pv_encryption_in_transit_enabled"],
                    launch_mode=var["instance_configuration_instance_details_launch_details_launch_mode"],
                    launch_options=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsLaunchOptionsArgs(
                        boot_volume_type=var["instance_configuration_instance_details_launch_details_launch_options_boot_volume_type"],
                        firmware=var["instance_configuration_instance_details_launch_details_launch_options_firmware"],
                        is_consistent_volume_naming_enabled=var["instance_configuration_instance_details_launch_details_launch_options_is_consistent_volume_naming_enabled"],
                        is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_launch_details_launch_options_is_pv_encryption_in_transit_enabled"],
                        network_type=var["instance_configuration_instance_details_launch_details_launch_options_network_type"],
                        remote_data_volume_type=var["instance_configuration_instance_details_launch_details_launch_options_remote_data_volume_type"],
                    ),
                    metadata=var["instance_configuration_instance_details_launch_details_metadata"],
                    platform_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsPlatformConfigArgs(
                        type=var["instance_configuration_instance_details_launch_details_platform_config_type"],
                        are_virtual_instructions_enabled=var["instance_configuration_instance_details_launch_details_platform_config_are_virtual_instructions_enabled"],
                        config_map=var["instance_configuration_instance_details_launch_details_platform_config_config_map"],
                        is_access_control_service_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_access_control_service_enabled"],
                        is_input_output_memory_management_unit_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_input_output_memory_management_unit_enabled"],
                        is_measured_boot_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_measured_boot_enabled"],
                        is_memory_encryption_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_memory_encryption_enabled"],
                        is_secure_boot_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_secure_boot_enabled"],
                        is_symmetric_multi_threading_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_symmetric_multi_threading_enabled"],
                        is_trusted_platform_module_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_trusted_platform_module_enabled"],
                        numa_nodes_per_socket=var["instance_configuration_instance_details_launch_details_platform_config_numa_nodes_per_socket"],
                        percentage_of_cores_enabled=var["instance_configuration_instance_details_launch_details_platform_config_percentage_of_cores_enabled"],
                    ),
                    preemptible_instance_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsPreemptibleInstanceConfigArgs(
                        preemption_action=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsPreemptibleInstanceConfigPreemptionActionArgs(
                            type=var["instance_configuration_instance_details_launch_details_preemptible_instance_config_preemption_action_type"],
                            preserve_boot_volume=var["instance_configuration_instance_details_launch_details_preemptible_instance_config_preemption_action_preserve_boot_volume"],
                        ),
                    ),
                    preferred_maintenance_action=var["instance_configuration_instance_details_launch_details_preferred_maintenance_action"],
                    shape=var["instance_configuration_instance_details_launch_details_shape"],
                    shape_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsShapeConfigArgs(
                        baseline_ocpu_utilization=var["instance_configuration_instance_details_launch_details_shape_config_baseline_ocpu_utilization"],
                        memory_in_gbs=var["instance_configuration_instance_details_launch_details_shape_config_memory_in_gbs"],
                        nvmes=var["instance_configuration_instance_details_launch_details_shape_config_nvmes"],
                        ocpus=var["instance_configuration_instance_details_launch_details_shape_config_ocpus"],
                        vcpus=var["instance_configuration_instance_details_launch_details_shape_config_vcpus"],
                    ),
                    source_details=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsSourceDetailsArgs(
                        source_type=var["instance_configuration_instance_details_launch_details_source_details_source_type"],
                        boot_volume_id=oci_core_boot_volume["test_boot_volume"]["id"],
                        boot_volume_size_in_gbs=var["instance_configuration_instance_details_launch_details_source_details_boot_volume_size_in_gbs"],
                        boot_volume_vpus_per_gb=var["instance_configuration_instance_details_launch_details_source_details_boot_volume_vpus_per_gb"],
                        image_id=oci_core_image["test_image"]["id"],
                        kms_key_id=oci_kms_key["test_key"]["id"],
                        instance_source_image_filter_details=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsSourceDetailsInstanceSourceImageFilterDetailsArgs(
                            compartment_id=var["compartment_id"],
                            defined_tags_filter=var["instance_configuration_instance_details_launch_details_source_details_instance_source_image_filter_details_defined_tags_filter"],
                            operating_system=var["instance_configuration_instance_details_launch_details_source_details_instance_source_image_filter_details_operating_system"],
                            operating_system_version=var["instance_configuration_instance_details_launch_details_source_details_instance_source_image_filter_details_operating_system_version"],
                        ),
                    ),
                ),
                options=[oci.core.InstanceConfigurationInstanceDetailsOptionArgs(
                    block_volumes=[oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeArgs(
                        attach_details=oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeAttachDetailsArgs(
                            type=var["instance_configuration_instance_details_options_block_volumes_attach_details_type"],
                            device=var["instance_configuration_instance_details_options_block_volumes_attach_details_device"],
                            display_name=var["instance_configuration_instance_details_options_block_volumes_attach_details_display_name"],
                            is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_options_block_volumes_attach_details_is_pv_encryption_in_transit_enabled"],
                            is_read_only=var["instance_configuration_instance_details_options_block_volumes_attach_details_is_read_only"],
                            is_shareable=var["instance_configuration_instance_details_options_block_volumes_attach_details_is_shareable"],
                            use_chap=var["instance_configuration_instance_details_options_block_volumes_attach_details_use_chap"],
                        ),
                        create_details=oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeCreateDetailsArgs(
                            autotune_policies=[oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeCreateDetailsAutotunePolicyArgs(
                                autotune_type=var["instance_configuration_instance_details_options_block_volumes_create_details_autotune_policies_autotune_type"],
                                max_vpus_per_gb=var["instance_configuration_instance_details_options_block_volumes_create_details_autotune_policies_max_vpus_per_gb"],
                            )],
                            availability_domain=var["instance_configuration_instance_details_options_block_volumes_create_details_availability_domain"],
                            backup_policy_id=data["oci_core_volume_backup_policies"]["test_volume_backup_policies"]["volume_backup_policies"][0]["id"],
                            compartment_id=var["compartment_id"],
                            defined_tags={
                                "Operations.CostCenter": "42",
                            },
                            display_name=var["instance_configuration_instance_details_options_block_volumes_create_details_display_name"],
                            freeform_tags={
                                "Department": "Finance",
                            },
                            kms_key_id=oci_kms_key["test_key"]["id"],
                            size_in_gbs=var["instance_configuration_instance_details_options_block_volumes_create_details_size_in_gbs"],
                            source_details=oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeCreateDetailsSourceDetailsArgs(
                                type=var["instance_configuration_instance_details_options_block_volumes_create_details_source_details_type"],
                                id=var["instance_configuration_instance_details_options_block_volumes_create_details_source_details_id"],
                            ),
                            vpus_per_gb=var["instance_configuration_instance_details_options_block_volumes_create_details_vpus_per_gb"],
                        ),
                        volume_id=oci_core_volume["test_volume"]["id"],
                    )],
                    launch_details=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsArgs(
                        agent_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsAgentConfigArgs(
                            are_all_plugins_disabled=var["instance_configuration_instance_details_options_launch_details_agent_config_are_all_plugins_disabled"],
                            is_management_disabled=var["instance_configuration_instance_details_options_launch_details_agent_config_is_management_disabled"],
                            is_monitoring_disabled=var["instance_configuration_instance_details_options_launch_details_agent_config_is_monitoring_disabled"],
                            plugins_configs=[oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsAgentConfigPluginsConfigArgs(
                                desired_state=var["instance_configuration_instance_details_options_launch_details_agent_config_plugins_config_desired_state"],
                                name=var["instance_configuration_instance_details_options_launch_details_agent_config_plugins_config_name"],
                            )],
                        ),
                        availability_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsAvailabilityConfigArgs(
                            recovery_action=var["instance_configuration_instance_details_options_launch_details_availability_config_recovery_action"],
                        ),
                        availability_domain=var["instance_configuration_instance_details_options_launch_details_availability_domain"],
                        capacity_reservation_id=oci_core_capacity_reservation["test_capacity_reservation"]["id"],
                        compartment_id=var["compartment_id"],
                        create_vnic_details=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsCreateVnicDetailsArgs(
                            assign_ipv6ip=var["instance_configuration_instance_details_launch_details_create_vnic_details_assign_ipv6ip"],
                            assign_private_dns_record=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_assign_private_dns_record"],
                            assign_public_ip=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_assign_public_ip"],
                            defined_tags={
                                "Operations.CostCenter": "42",
                            },
                            display_name=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_display_name"],
                            freeform_tags={
                                "Department": "Finance",
                            },
                            hostname_label=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_hostname_label"],
                            ipv6address_ipv6subnet_cidr_pair_details=[oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsCreateVnicDetailsIpv6addressIpv6subnetCidrPairDetailArgs(
                                ipv6address=var["instance_configuration_instance_details_launch_details_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6address"],
                                ipv6subnet_cidr=var["instance_configuration_instance_details_launch_details_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6subnet_cidr"],
                            )],
                            nsg_ids=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_nsg_ids"],
                            private_ip=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_private_ip"],
                            skip_source_dest_check=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_skip_source_dest_check"],
                            subnet_id=oci_core_subnet["test_subnet"]["id"],
                        ),
                        dedicated_vm_host_id=oci_core_dedicated_vm_host["test_dedicated_vm_host"]["id"],
                        defined_tags={
                            "Operations.CostCenter": "42",
                        },
                        display_name=var["instance_configuration_instance_details_options_launch_details_display_name"],
                        extended_metadata=var["instance_configuration_instance_details_options_launch_details_extended_metadata"],
                        fault_domain=var["instance_configuration_instance_details_options_launch_details_fault_domain"],
                        freeform_tags={
                            "Department": "Finance",
                        },
                        instance_options=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsInstanceOptionsArgs(
                            are_legacy_imds_endpoints_disabled=var["instance_configuration_instance_details_options_launch_details_instance_options_are_legacy_imds_endpoints_disabled"],
                        ),
                        ipxe_script=var["instance_configuration_instance_details_options_launch_details_ipxe_script"],
                        is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_options_launch_details_is_pv_encryption_in_transit_enabled"],
                        launch_mode=var["instance_configuration_instance_details_options_launch_details_launch_mode"],
                        launch_options=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsLaunchOptionsArgs(
                            boot_volume_type=var["instance_configuration_instance_details_options_launch_details_launch_options_boot_volume_type"],
                            firmware=var["instance_configuration_instance_details_options_launch_details_launch_options_firmware"],
                            is_consistent_volume_naming_enabled=var["instance_configuration_instance_details_options_launch_details_launch_options_is_consistent_volume_naming_enabled"],
                            is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_options_launch_details_launch_options_is_pv_encryption_in_transit_enabled"],
                            network_type=var["instance_configuration_instance_details_options_launch_details_launch_options_network_type"],
                            remote_data_volume_type=var["instance_configuration_instance_details_options_launch_details_launch_options_remote_data_volume_type"],
                        ),
                        metadata=var["instance_configuration_instance_details_options_launch_details_metadata"],
                        platform_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsPlatformConfigArgs(
                            type=var["instance_configuration_instance_details_options_launch_details_platform_config_type"],
                            are_virtual_instructions_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_are_virtual_instructions_enabled"],
                            is_access_control_service_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_access_control_service_enabled"],
                            is_input_output_memory_management_unit_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_input_output_memory_management_unit_enabled"],
                            is_measured_boot_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_measured_boot_enabled"],
                            is_memory_encryption_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_memory_encryption_enabled"],
                            is_secure_boot_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_secure_boot_enabled"],
                            is_symmetric_multi_threading_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_symmetric_multi_threading_enabled"],
                            is_trusted_platform_module_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_trusted_platform_module_enabled"],
                            numa_nodes_per_socket=var["instance_configuration_instance_details_options_launch_details_platform_config_numa_nodes_per_socket"],
                            percentage_of_cores_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_percentage_of_cores_enabled"],
                        ),
                        preemptible_instance_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsPreemptibleInstanceConfigArgs(
                            preemption_action=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsPreemptibleInstanceConfigPreemptionActionArgs(
                                type=var["instance_configuration_instance_details_options_launch_details_preemptible_instance_config_preemption_action_type"],
                                preserve_boot_volume=var["instance_configuration_instance_details_options_launch_details_preemptible_instance_config_preemption_action_preserve_boot_volume"],
                            ),
                        ),
                        preferred_maintenance_action=var["instance_configuration_instance_details_options_launch_details_preferred_maintenance_action"],
                        shape=var["instance_configuration_instance_details_options_launch_details_shape"],
                        shape_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsShapeConfigArgs(
                            baseline_ocpu_utilization=var["instance_configuration_instance_details_options_launch_details_shape_config_baseline_ocpu_utilization"],
                            memory_in_gbs=var["instance_configuration_instance_details_options_launch_details_shape_config_memory_in_gbs"],
                            nvmes=var["instance_configuration_instance_details_options_launch_details_shape_config_nvmes"],
                            ocpus=var["instance_configuration_instance_details_options_launch_details_shape_config_ocpus"],
                            vcpus=var["instance_configuration_instance_details_options_launch_details_shape_config_vcpus"],
                        ),
                        source_details=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsSourceDetailsArgs(
                            source_type=var["instance_configuration_instance_details_options_launch_details_source_details_source_type"],
                            boot_volume_id=oci_core_boot_volume["test_boot_volume"]["id"],
                            boot_volume_size_in_gbs=var["instance_configuration_instance_details_options_launch_details_source_details_boot_volume_size_in_gbs"],
                            boot_volume_vpus_per_gb=var["instance_configuration_instance_details_options_launch_details_source_details_boot_volume_vpus_per_gb"],
                            image_id=oci_core_image["test_image"]["id"],
                            instance_source_image_filter_details=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsSourceDetailsInstanceSourceImageFilterDetailsArgs(
                                compartment_id=var["compartment_id"],
                                defined_tags_filter=var["instance_configuration_instance_details_options_launch_details_source_details_instance_source_image_filter_details_defined_tags_filter"],
                                operating_system=var["instance_configuration_instance_details_options_launch_details_source_details_instance_source_image_filter_details_operating_system"],
                                operating_system_version=var["instance_configuration_instance_details_options_launch_details_source_details_instance_source_image_filter_details_operating_system_version"],
                            ),
                        ),
                    ),
                    secondary_vnics=[oci.core.InstanceConfigurationInstanceDetailsOptionSecondaryVnicArgs(
                        create_vnic_details=oci.core.InstanceConfigurationInstanceDetailsOptionSecondaryVnicCreateVnicDetailsArgs(
                            assign_ipv6ip=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_assign_ipv6ip"],
                            assign_private_dns_record=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_assign_private_dns_record"],
                            assign_public_ip=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_assign_public_ip"],
                            defined_tags={
                                "Operations.CostCenter": "42",
                            },
                            display_name=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_display_name"],
                            freeform_tags={
                                "Department": "Finance",
                            },
                            hostname_label=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_hostname_label"],
                            ipv6address_ipv6subnet_cidr_pair_details=[oci.core.InstanceConfigurationInstanceDetailsOptionSecondaryVnicCreateVnicDetailsIpv6addressIpv6subnetCidrPairDetailArgs(
                                ipv6address=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6address"],
                                ipv6subnet_cidr=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6subnet_cidr"],
                            )],
                            nsg_ids=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_nsg_ids"],
                            private_ip=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_private_ip"],
                            skip_source_dest_check=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_skip_source_dest_check"],
                            subnet_id=oci_core_subnet["test_subnet"]["id"],
                        ),
                        display_name=var["instance_configuration_instance_details_options_secondary_vnics_display_name"],
                        nic_index=var["instance_configuration_instance_details_options_secondary_vnics_nic_index"],
                    )],
                )],
                secondary_vnics=[oci.core.InstanceConfigurationInstanceDetailsSecondaryVnicArgs(
                    create_vnic_details=oci.core.InstanceConfigurationInstanceDetailsSecondaryVnicCreateVnicDetailsArgs(
                        assign_private_dns_record=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_assign_private_dns_record"],
                        assign_public_ip=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_assign_public_ip"],
                        defined_tags={
                            "Operations.CostCenter": "42",
                        },
                        display_name=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_display_name"],
                        freeform_tags={
                            "Department": "Finance",
                        },
                        hostname_label=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_hostname_label"],
                        nsg_ids=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_nsg_ids"],
                        private_ip=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_private_ip"],
                        skip_source_dest_check=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_skip_source_dest_check"],
                        subnet_id=oci_core_subnet["test_subnet"]["id"],
                    ),
                    display_name=var["instance_configuration_instance_details_secondary_vnics_display_name"],
                    nic_index=var["instance_configuration_instance_details_secondary_vnics_nic_index"],
                )],
            ),
            instance_id=oci_core_instance["test_instance"]["id"],
            source=var["instance_configuration_source"])
        ```

        ## Import

        InstanceConfigurations can be imported using the `id`, e.g.

        ```sh
         $ pulumi import oci:Core/instanceConfiguration:InstanceConfiguration test_instance_configuration "id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] compartment_id: (Updatable) The OCID of the compartment containing images to search
        :param pulumi.Input[Mapping[str, Any]] defined_tags: Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param pulumi.Input[str] display_name: A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        :param pulumi.Input[Mapping[str, Any]] freeform_tags: Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        :param pulumi.Input[str] instance_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the instance to use to create the instance configuration.
        :param pulumi.Input[str] source: The source of the instance configuration. An instance configuration defines the settings to use when creating Compute instances, including details such as the base image, shape, and metadata. You can also specify the associated resources for the instance, such as block volume attachments and network configuration.
               
               When you create an instance configuration using an existing instance as a template, the instance configuration does not include any information from the source instance's boot volume, such as installed applications, binaries, and files on the instance. It also does not include the contents of any block volumes that are attached to the instance.
               
               To create an instance configuration that includes the custom setup from an instance's boot volume, you must first create a custom image from the instance (see [CreateImage](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Image/CreateImage)). Then, use the custom image to launch a new instance (see [LaunchInstance](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstance)). Finally, create the instance configuration based on the instance that you created from the custom image.
               
               To include block volume contents with an instance configuration, first create a backup of the attached block volumes (see [CreateVolumeBackup](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/VolumeBackup/CreateVolumeBackup)). Then, create the instance configuration by specifying the list of settings, using [InstanceConfigurationVolumeSourceFromVolumeBackupDetails](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/datatypes/InstanceConfigurationVolumeSourceFromVolumeBackupDetails) to include the block volume backups in the list of settings.
               
               The following values are supported:
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InstanceConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource provides the Instance Configuration resource in Oracle Cloud Infrastructure Core service.

        Creates an instance configuration. An instance configuration is a template that defines the
        settings to use when creating Compute instances.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_oci as oci

        test_instance_configuration = oci.core.InstanceConfiguration("testInstanceConfiguration",
            compartment_id=var["compartment_id"],
            defined_tags={
                "Operations.CostCenter": "42",
            },
            display_name=var["instance_configuration_display_name"],
            freeform_tags={
                "Department": "Finance",
            },
            instance_details=oci.core.InstanceConfigurationInstanceDetailsArgs(
                instance_type=var["instance_configuration_instance_details_instance_type"],
                block_volumes=[oci.core.InstanceConfigurationInstanceDetailsBlockVolumeArgs(
                    attach_details=oci.core.InstanceConfigurationInstanceDetailsBlockVolumeAttachDetailsArgs(
                        type=var["instance_configuration_instance_details_block_volumes_attach_details_type"],
                        device=var["instance_configuration_instance_details_block_volumes_attach_details_device"],
                        display_name=var["instance_configuration_instance_details_block_volumes_attach_details_display_name"],
                        is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_block_volumes_attach_details_is_pv_encryption_in_transit_enabled"],
                        is_read_only=var["instance_configuration_instance_details_block_volumes_attach_details_is_read_only"],
                        is_shareable=var["instance_configuration_instance_details_block_volumes_attach_details_is_shareable"],
                        use_chap=var["instance_configuration_instance_details_block_volumes_attach_details_use_chap"],
                    ),
                    create_details=oci.core.InstanceConfigurationInstanceDetailsBlockVolumeCreateDetailsArgs(
                        autotune_policies=[oci.core.InstanceConfigurationInstanceDetailsBlockVolumeCreateDetailsAutotunePolicyArgs(
                            autotune_type=var["instance_configuration_instance_details_block_volumes_create_details_autotune_policies_autotune_type"],
                            max_vpus_per_gb=var["instance_configuration_instance_details_block_volumes_create_details_autotune_policies_max_vpus_per_gb"],
                        )],
                        availability_domain=var["instance_configuration_instance_details_block_volumes_create_details_availability_domain"],
                        backup_policy_id=data["oci_core_volume_backup_policies"]["test_volume_backup_policies"]["volume_backup_policies"][0]["id"],
                        block_volume_replicas=oci.core.InstanceConfigurationInstanceDetailsBlockVolumeCreateDetailsBlockVolumeReplicasArgs(
                            availability_domain=var["instance_configuration_instance_details_block_volumes_create_details_block_volume_replicas_availability_domain"],
                            display_name=var["instance_configuration_instance_details_block_volumes_create_details_block_volume_replicas_display_name"],
                        ),
                        compartment_id=var["compartment_id"],
                        defined_tags={
                            "Operations.CostCenter": "42",
                        },
                        display_name=var["instance_configuration_instance_details_block_volumes_create_details_display_name"],
                        freeform_tags={
                            "Department": "Finance",
                        },
                        is_auto_tune_enabled=var["instance_configuration_instance_details_block_volumes_create_details_is_auto_tune_enabled"],
                        kms_key_id=oci_kms_key["test_key"]["id"],
                        size_in_gbs=var["instance_configuration_instance_details_block_volumes_create_details_size_in_gbs"],
                        source_details=oci.core.InstanceConfigurationInstanceDetailsBlockVolumeCreateDetailsSourceDetailsArgs(
                            type=var["instance_configuration_instance_details_block_volumes_create_details_source_details_type"],
                            id=var["instance_configuration_instance_details_block_volumes_create_details_source_details_id"],
                        ),
                        vpus_per_gb=var["instance_configuration_instance_details_block_volumes_create_details_vpus_per_gb"],
                    ),
                    volume_id=oci_core_volume["test_volume"]["id"],
                )],
                launch_details=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsArgs(
                    agent_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsAgentConfigArgs(
                        are_all_plugins_disabled=var["instance_configuration_instance_details_launch_details_agent_config_are_all_plugins_disabled"],
                        is_management_disabled=var["instance_configuration_instance_details_launch_details_agent_config_is_management_disabled"],
                        is_monitoring_disabled=var["instance_configuration_instance_details_launch_details_agent_config_is_monitoring_disabled"],
                        plugins_configs=[oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsAgentConfigPluginsConfigArgs(
                            desired_state=var["instance_configuration_instance_details_launch_details_agent_config_plugins_config_desired_state"],
                            name=var["instance_configuration_instance_details_launch_details_agent_config_plugins_config_name"],
                        )],
                    ),
                    availability_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsAvailabilityConfigArgs(
                        is_live_migration_preferred=var["instance_configuration_instance_details_launch_details_availability_config_is_live_migration_preferred"],
                        recovery_action=var["instance_configuration_instance_details_launch_details_availability_config_recovery_action"],
                    ),
                    availability_domain=var["instance_configuration_instance_details_launch_details_availability_domain"],
                    capacity_reservation_id=oci_core_capacity_reservation["test_capacity_reservation"]["id"],
                    compartment_id=var["compartment_id"],
                    create_vnic_details=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsCreateVnicDetailsArgs(
                        assign_ipv6ip=var["instance_configuration_instance_details_launch_details_create_vnic_details_assign_ipv6ip"],
                        assign_private_dns_record=var["instance_configuration_instance_details_launch_details_create_vnic_details_assign_private_dns_record"],
                        assign_public_ip=var["instance_configuration_instance_details_launch_details_create_vnic_details_assign_public_ip"],
                        defined_tags={
                            "Operations.CostCenter": "42",
                        },
                        display_name=var["instance_configuration_instance_details_launch_details_create_vnic_details_display_name"],
                        freeform_tags={
                            "Department": "Finance",
                        },
                        hostname_label=var["instance_configuration_instance_details_launch_details_create_vnic_details_hostname_label"],
                        ipv6address_ipv6subnet_cidr_pair_details=[oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsCreateVnicDetailsIpv6addressIpv6subnetCidrPairDetailArgs(
                            ipv6address=var["instance_configuration_instance_details_launch_details_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6address"],
                            ipv6subnet_cidr=var["instance_configuration_instance_details_launch_details_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6subnet_cidr"],
                        )],
                        nsg_ids=var["instance_configuration_instance_details_launch_details_create_vnic_details_nsg_ids"],
                        private_ip=var["instance_configuration_instance_details_launch_details_create_vnic_details_private_ip"],
                        skip_source_dest_check=var["instance_configuration_instance_details_launch_details_create_vnic_details_skip_source_dest_check"],
                        subnet_id=oci_core_subnet["test_subnet"]["id"],
                    ),
                    dedicated_vm_host_id=oci_core_dedicated_vm_host["test_dedicated_vm_host"]["id"],
                    defined_tags={
                        "Operations.CostCenter": "42",
                    },
                    display_name=var["instance_configuration_instance_details_launch_details_display_name"],
                    extended_metadata=var["instance_configuration_instance_details_launch_details_extended_metadata"],
                    fault_domain=var["instance_configuration_instance_details_launch_details_fault_domain"],
                    freeform_tags={
                        "Department": "Finance",
                    },
                    instance_options=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsInstanceOptionsArgs(
                        are_legacy_imds_endpoints_disabled=var["instance_configuration_instance_details_launch_details_instance_options_are_legacy_imds_endpoints_disabled"],
                    ),
                    ipxe_script=var["instance_configuration_instance_details_launch_details_ipxe_script"],
                    is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_launch_details_is_pv_encryption_in_transit_enabled"],
                    launch_mode=var["instance_configuration_instance_details_launch_details_launch_mode"],
                    launch_options=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsLaunchOptionsArgs(
                        boot_volume_type=var["instance_configuration_instance_details_launch_details_launch_options_boot_volume_type"],
                        firmware=var["instance_configuration_instance_details_launch_details_launch_options_firmware"],
                        is_consistent_volume_naming_enabled=var["instance_configuration_instance_details_launch_details_launch_options_is_consistent_volume_naming_enabled"],
                        is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_launch_details_launch_options_is_pv_encryption_in_transit_enabled"],
                        network_type=var["instance_configuration_instance_details_launch_details_launch_options_network_type"],
                        remote_data_volume_type=var["instance_configuration_instance_details_launch_details_launch_options_remote_data_volume_type"],
                    ),
                    metadata=var["instance_configuration_instance_details_launch_details_metadata"],
                    platform_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsPlatformConfigArgs(
                        type=var["instance_configuration_instance_details_launch_details_platform_config_type"],
                        are_virtual_instructions_enabled=var["instance_configuration_instance_details_launch_details_platform_config_are_virtual_instructions_enabled"],
                        config_map=var["instance_configuration_instance_details_launch_details_platform_config_config_map"],
                        is_access_control_service_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_access_control_service_enabled"],
                        is_input_output_memory_management_unit_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_input_output_memory_management_unit_enabled"],
                        is_measured_boot_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_measured_boot_enabled"],
                        is_memory_encryption_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_memory_encryption_enabled"],
                        is_secure_boot_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_secure_boot_enabled"],
                        is_symmetric_multi_threading_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_symmetric_multi_threading_enabled"],
                        is_trusted_platform_module_enabled=var["instance_configuration_instance_details_launch_details_platform_config_is_trusted_platform_module_enabled"],
                        numa_nodes_per_socket=var["instance_configuration_instance_details_launch_details_platform_config_numa_nodes_per_socket"],
                        percentage_of_cores_enabled=var["instance_configuration_instance_details_launch_details_platform_config_percentage_of_cores_enabled"],
                    ),
                    preemptible_instance_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsPreemptibleInstanceConfigArgs(
                        preemption_action=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsPreemptibleInstanceConfigPreemptionActionArgs(
                            type=var["instance_configuration_instance_details_launch_details_preemptible_instance_config_preemption_action_type"],
                            preserve_boot_volume=var["instance_configuration_instance_details_launch_details_preemptible_instance_config_preemption_action_preserve_boot_volume"],
                        ),
                    ),
                    preferred_maintenance_action=var["instance_configuration_instance_details_launch_details_preferred_maintenance_action"],
                    shape=var["instance_configuration_instance_details_launch_details_shape"],
                    shape_config=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsShapeConfigArgs(
                        baseline_ocpu_utilization=var["instance_configuration_instance_details_launch_details_shape_config_baseline_ocpu_utilization"],
                        memory_in_gbs=var["instance_configuration_instance_details_launch_details_shape_config_memory_in_gbs"],
                        nvmes=var["instance_configuration_instance_details_launch_details_shape_config_nvmes"],
                        ocpus=var["instance_configuration_instance_details_launch_details_shape_config_ocpus"],
                        vcpus=var["instance_configuration_instance_details_launch_details_shape_config_vcpus"],
                    ),
                    source_details=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsSourceDetailsArgs(
                        source_type=var["instance_configuration_instance_details_launch_details_source_details_source_type"],
                        boot_volume_id=oci_core_boot_volume["test_boot_volume"]["id"],
                        boot_volume_size_in_gbs=var["instance_configuration_instance_details_launch_details_source_details_boot_volume_size_in_gbs"],
                        boot_volume_vpus_per_gb=var["instance_configuration_instance_details_launch_details_source_details_boot_volume_vpus_per_gb"],
                        image_id=oci_core_image["test_image"]["id"],
                        kms_key_id=oci_kms_key["test_key"]["id"],
                        instance_source_image_filter_details=oci.core.InstanceConfigurationInstanceDetailsLaunchDetailsSourceDetailsInstanceSourceImageFilterDetailsArgs(
                            compartment_id=var["compartment_id"],
                            defined_tags_filter=var["instance_configuration_instance_details_launch_details_source_details_instance_source_image_filter_details_defined_tags_filter"],
                            operating_system=var["instance_configuration_instance_details_launch_details_source_details_instance_source_image_filter_details_operating_system"],
                            operating_system_version=var["instance_configuration_instance_details_launch_details_source_details_instance_source_image_filter_details_operating_system_version"],
                        ),
                    ),
                ),
                options=[oci.core.InstanceConfigurationInstanceDetailsOptionArgs(
                    block_volumes=[oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeArgs(
                        attach_details=oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeAttachDetailsArgs(
                            type=var["instance_configuration_instance_details_options_block_volumes_attach_details_type"],
                            device=var["instance_configuration_instance_details_options_block_volumes_attach_details_device"],
                            display_name=var["instance_configuration_instance_details_options_block_volumes_attach_details_display_name"],
                            is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_options_block_volumes_attach_details_is_pv_encryption_in_transit_enabled"],
                            is_read_only=var["instance_configuration_instance_details_options_block_volumes_attach_details_is_read_only"],
                            is_shareable=var["instance_configuration_instance_details_options_block_volumes_attach_details_is_shareable"],
                            use_chap=var["instance_configuration_instance_details_options_block_volumes_attach_details_use_chap"],
                        ),
                        create_details=oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeCreateDetailsArgs(
                            autotune_policies=[oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeCreateDetailsAutotunePolicyArgs(
                                autotune_type=var["instance_configuration_instance_details_options_block_volumes_create_details_autotune_policies_autotune_type"],
                                max_vpus_per_gb=var["instance_configuration_instance_details_options_block_volumes_create_details_autotune_policies_max_vpus_per_gb"],
                            )],
                            availability_domain=var["instance_configuration_instance_details_options_block_volumes_create_details_availability_domain"],
                            backup_policy_id=data["oci_core_volume_backup_policies"]["test_volume_backup_policies"]["volume_backup_policies"][0]["id"],
                            compartment_id=var["compartment_id"],
                            defined_tags={
                                "Operations.CostCenter": "42",
                            },
                            display_name=var["instance_configuration_instance_details_options_block_volumes_create_details_display_name"],
                            freeform_tags={
                                "Department": "Finance",
                            },
                            kms_key_id=oci_kms_key["test_key"]["id"],
                            size_in_gbs=var["instance_configuration_instance_details_options_block_volumes_create_details_size_in_gbs"],
                            source_details=oci.core.InstanceConfigurationInstanceDetailsOptionBlockVolumeCreateDetailsSourceDetailsArgs(
                                type=var["instance_configuration_instance_details_options_block_volumes_create_details_source_details_type"],
                                id=var["instance_configuration_instance_details_options_block_volumes_create_details_source_details_id"],
                            ),
                            vpus_per_gb=var["instance_configuration_instance_details_options_block_volumes_create_details_vpus_per_gb"],
                        ),
                        volume_id=oci_core_volume["test_volume"]["id"],
                    )],
                    launch_details=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsArgs(
                        agent_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsAgentConfigArgs(
                            are_all_plugins_disabled=var["instance_configuration_instance_details_options_launch_details_agent_config_are_all_plugins_disabled"],
                            is_management_disabled=var["instance_configuration_instance_details_options_launch_details_agent_config_is_management_disabled"],
                            is_monitoring_disabled=var["instance_configuration_instance_details_options_launch_details_agent_config_is_monitoring_disabled"],
                            plugins_configs=[oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsAgentConfigPluginsConfigArgs(
                                desired_state=var["instance_configuration_instance_details_options_launch_details_agent_config_plugins_config_desired_state"],
                                name=var["instance_configuration_instance_details_options_launch_details_agent_config_plugins_config_name"],
                            )],
                        ),
                        availability_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsAvailabilityConfigArgs(
                            recovery_action=var["instance_configuration_instance_details_options_launch_details_availability_config_recovery_action"],
                        ),
                        availability_domain=var["instance_configuration_instance_details_options_launch_details_availability_domain"],
                        capacity_reservation_id=oci_core_capacity_reservation["test_capacity_reservation"]["id"],
                        compartment_id=var["compartment_id"],
                        create_vnic_details=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsCreateVnicDetailsArgs(
                            assign_ipv6ip=var["instance_configuration_instance_details_launch_details_create_vnic_details_assign_ipv6ip"],
                            assign_private_dns_record=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_assign_private_dns_record"],
                            assign_public_ip=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_assign_public_ip"],
                            defined_tags={
                                "Operations.CostCenter": "42",
                            },
                            display_name=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_display_name"],
                            freeform_tags={
                                "Department": "Finance",
                            },
                            hostname_label=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_hostname_label"],
                            ipv6address_ipv6subnet_cidr_pair_details=[oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsCreateVnicDetailsIpv6addressIpv6subnetCidrPairDetailArgs(
                                ipv6address=var["instance_configuration_instance_details_launch_details_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6address"],
                                ipv6subnet_cidr=var["instance_configuration_instance_details_launch_details_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6subnet_cidr"],
                            )],
                            nsg_ids=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_nsg_ids"],
                            private_ip=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_private_ip"],
                            skip_source_dest_check=var["instance_configuration_instance_details_options_launch_details_create_vnic_details_skip_source_dest_check"],
                            subnet_id=oci_core_subnet["test_subnet"]["id"],
                        ),
                        dedicated_vm_host_id=oci_core_dedicated_vm_host["test_dedicated_vm_host"]["id"],
                        defined_tags={
                            "Operations.CostCenter": "42",
                        },
                        display_name=var["instance_configuration_instance_details_options_launch_details_display_name"],
                        extended_metadata=var["instance_configuration_instance_details_options_launch_details_extended_metadata"],
                        fault_domain=var["instance_configuration_instance_details_options_launch_details_fault_domain"],
                        freeform_tags={
                            "Department": "Finance",
                        },
                        instance_options=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsInstanceOptionsArgs(
                            are_legacy_imds_endpoints_disabled=var["instance_configuration_instance_details_options_launch_details_instance_options_are_legacy_imds_endpoints_disabled"],
                        ),
                        ipxe_script=var["instance_configuration_instance_details_options_launch_details_ipxe_script"],
                        is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_options_launch_details_is_pv_encryption_in_transit_enabled"],
                        launch_mode=var["instance_configuration_instance_details_options_launch_details_launch_mode"],
                        launch_options=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsLaunchOptionsArgs(
                            boot_volume_type=var["instance_configuration_instance_details_options_launch_details_launch_options_boot_volume_type"],
                            firmware=var["instance_configuration_instance_details_options_launch_details_launch_options_firmware"],
                            is_consistent_volume_naming_enabled=var["instance_configuration_instance_details_options_launch_details_launch_options_is_consistent_volume_naming_enabled"],
                            is_pv_encryption_in_transit_enabled=var["instance_configuration_instance_details_options_launch_details_launch_options_is_pv_encryption_in_transit_enabled"],
                            network_type=var["instance_configuration_instance_details_options_launch_details_launch_options_network_type"],
                            remote_data_volume_type=var["instance_configuration_instance_details_options_launch_details_launch_options_remote_data_volume_type"],
                        ),
                        metadata=var["instance_configuration_instance_details_options_launch_details_metadata"],
                        platform_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsPlatformConfigArgs(
                            type=var["instance_configuration_instance_details_options_launch_details_platform_config_type"],
                            are_virtual_instructions_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_are_virtual_instructions_enabled"],
                            is_access_control_service_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_access_control_service_enabled"],
                            is_input_output_memory_management_unit_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_input_output_memory_management_unit_enabled"],
                            is_measured_boot_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_measured_boot_enabled"],
                            is_memory_encryption_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_memory_encryption_enabled"],
                            is_secure_boot_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_secure_boot_enabled"],
                            is_symmetric_multi_threading_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_symmetric_multi_threading_enabled"],
                            is_trusted_platform_module_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_is_trusted_platform_module_enabled"],
                            numa_nodes_per_socket=var["instance_configuration_instance_details_options_launch_details_platform_config_numa_nodes_per_socket"],
                            percentage_of_cores_enabled=var["instance_configuration_instance_details_options_launch_details_platform_config_percentage_of_cores_enabled"],
                        ),
                        preemptible_instance_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsPreemptibleInstanceConfigArgs(
                            preemption_action=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsPreemptibleInstanceConfigPreemptionActionArgs(
                                type=var["instance_configuration_instance_details_options_launch_details_preemptible_instance_config_preemption_action_type"],
                                preserve_boot_volume=var["instance_configuration_instance_details_options_launch_details_preemptible_instance_config_preemption_action_preserve_boot_volume"],
                            ),
                        ),
                        preferred_maintenance_action=var["instance_configuration_instance_details_options_launch_details_preferred_maintenance_action"],
                        shape=var["instance_configuration_instance_details_options_launch_details_shape"],
                        shape_config=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsShapeConfigArgs(
                            baseline_ocpu_utilization=var["instance_configuration_instance_details_options_launch_details_shape_config_baseline_ocpu_utilization"],
                            memory_in_gbs=var["instance_configuration_instance_details_options_launch_details_shape_config_memory_in_gbs"],
                            nvmes=var["instance_configuration_instance_details_options_launch_details_shape_config_nvmes"],
                            ocpus=var["instance_configuration_instance_details_options_launch_details_shape_config_ocpus"],
                            vcpus=var["instance_configuration_instance_details_options_launch_details_shape_config_vcpus"],
                        ),
                        source_details=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsSourceDetailsArgs(
                            source_type=var["instance_configuration_instance_details_options_launch_details_source_details_source_type"],
                            boot_volume_id=oci_core_boot_volume["test_boot_volume"]["id"],
                            boot_volume_size_in_gbs=var["instance_configuration_instance_details_options_launch_details_source_details_boot_volume_size_in_gbs"],
                            boot_volume_vpus_per_gb=var["instance_configuration_instance_details_options_launch_details_source_details_boot_volume_vpus_per_gb"],
                            image_id=oci_core_image["test_image"]["id"],
                            instance_source_image_filter_details=oci.core.InstanceConfigurationInstanceDetailsOptionLaunchDetailsSourceDetailsInstanceSourceImageFilterDetailsArgs(
                                compartment_id=var["compartment_id"],
                                defined_tags_filter=var["instance_configuration_instance_details_options_launch_details_source_details_instance_source_image_filter_details_defined_tags_filter"],
                                operating_system=var["instance_configuration_instance_details_options_launch_details_source_details_instance_source_image_filter_details_operating_system"],
                                operating_system_version=var["instance_configuration_instance_details_options_launch_details_source_details_instance_source_image_filter_details_operating_system_version"],
                            ),
                        ),
                    ),
                    secondary_vnics=[oci.core.InstanceConfigurationInstanceDetailsOptionSecondaryVnicArgs(
                        create_vnic_details=oci.core.InstanceConfigurationInstanceDetailsOptionSecondaryVnicCreateVnicDetailsArgs(
                            assign_ipv6ip=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_assign_ipv6ip"],
                            assign_private_dns_record=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_assign_private_dns_record"],
                            assign_public_ip=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_assign_public_ip"],
                            defined_tags={
                                "Operations.CostCenter": "42",
                            },
                            display_name=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_display_name"],
                            freeform_tags={
                                "Department": "Finance",
                            },
                            hostname_label=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_hostname_label"],
                            ipv6address_ipv6subnet_cidr_pair_details=[oci.core.InstanceConfigurationInstanceDetailsOptionSecondaryVnicCreateVnicDetailsIpv6addressIpv6subnetCidrPairDetailArgs(
                                ipv6address=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6address"],
                                ipv6subnet_cidr=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_ipv6address_ipv6subnet_cidr_pair_details_ipv6subnet_cidr"],
                            )],
                            nsg_ids=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_nsg_ids"],
                            private_ip=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_private_ip"],
                            skip_source_dest_check=var["instance_configuration_instance_details_options_secondary_vnics_create_vnic_details_skip_source_dest_check"],
                            subnet_id=oci_core_subnet["test_subnet"]["id"],
                        ),
                        display_name=var["instance_configuration_instance_details_options_secondary_vnics_display_name"],
                        nic_index=var["instance_configuration_instance_details_options_secondary_vnics_nic_index"],
                    )],
                )],
                secondary_vnics=[oci.core.InstanceConfigurationInstanceDetailsSecondaryVnicArgs(
                    create_vnic_details=oci.core.InstanceConfigurationInstanceDetailsSecondaryVnicCreateVnicDetailsArgs(
                        assign_private_dns_record=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_assign_private_dns_record"],
                        assign_public_ip=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_assign_public_ip"],
                        defined_tags={
                            "Operations.CostCenter": "42",
                        },
                        display_name=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_display_name"],
                        freeform_tags={
                            "Department": "Finance",
                        },
                        hostname_label=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_hostname_label"],
                        nsg_ids=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_nsg_ids"],
                        private_ip=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_private_ip"],
                        skip_source_dest_check=var["instance_configuration_instance_details_secondary_vnics_create_vnic_details_skip_source_dest_check"],
                        subnet_id=oci_core_subnet["test_subnet"]["id"],
                    ),
                    display_name=var["instance_configuration_instance_details_secondary_vnics_display_name"],
                    nic_index=var["instance_configuration_instance_details_secondary_vnics_nic_index"],
                )],
            ),
            instance_id=oci_core_instance["test_instance"]["id"],
            source=var["instance_configuration_source"])
        ```

        ## Import

        InstanceConfigurations can be imported using the `id`, e.g.

        ```sh
         $ pulumi import oci:Core/instanceConfiguration:InstanceConfiguration test_instance_configuration "id"
        ```

        :param str resource_name: The name of the resource.
        :param InstanceConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InstanceConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            InstanceConfigurationArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 compartment_id: Optional[pulumi.Input[str]] = None,
                 defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 instance_details: Optional[pulumi.Input[pulumi.InputType['InstanceConfigurationInstanceDetailsArgs']]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InstanceConfigurationArgs.__new__(InstanceConfigurationArgs)

            if compartment_id is None and not opts.urn:
                raise TypeError("Missing required property 'compartment_id'")
            __props__.__dict__["compartment_id"] = compartment_id
            __props__.__dict__["defined_tags"] = defined_tags
            __props__.__dict__["display_name"] = display_name
            __props__.__dict__["freeform_tags"] = freeform_tags
            if instance_details is not None and not isinstance(instance_details, InstanceConfigurationInstanceDetailsArgs):
                instance_details = instance_details or {}
                def _setter(key, value):
                    instance_details[key] = value
                InstanceConfigurationInstanceDetailsArgs._configure(_setter, **instance_details)
            __props__.__dict__["instance_details"] = instance_details
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["source"] = source
            __props__.__dict__["deferred_fields"] = None
            __props__.__dict__["time_created"] = None
        super(InstanceConfiguration, __self__).__init__(
            'oci:Core/instanceConfiguration:InstanceConfiguration',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            compartment_id: Optional[pulumi.Input[str]] = None,
            deferred_fields: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            defined_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            display_name: Optional[pulumi.Input[str]] = None,
            freeform_tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            instance_details: Optional[pulumi.Input[pulumi.InputType['InstanceConfigurationInstanceDetailsArgs']]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            source: Optional[pulumi.Input[str]] = None,
            time_created: Optional[pulumi.Input[str]] = None) -> 'InstanceConfiguration':
        """
        Get an existing InstanceConfiguration resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] compartment_id: (Updatable) The OCID of the compartment containing images to search
        :param pulumi.Input[Sequence[pulumi.Input[str]]] deferred_fields: Parameters that were not specified when the instance configuration was created, but that are required to launch an instance from the instance configuration. See the [LaunchInstanceConfiguration](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstanceConfiguration) operation.
        :param pulumi.Input[Mapping[str, Any]] defined_tags: Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param pulumi.Input[str] display_name: A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        :param pulumi.Input[Mapping[str, Any]] freeform_tags: Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        :param pulumi.Input[str] instance_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the instance to use to create the instance configuration.
        :param pulumi.Input[str] source: The source of the instance configuration. An instance configuration defines the settings to use when creating Compute instances, including details such as the base image, shape, and metadata. You can also specify the associated resources for the instance, such as block volume attachments and network configuration.
               
               When you create an instance configuration using an existing instance as a template, the instance configuration does not include any information from the source instance's boot volume, such as installed applications, binaries, and files on the instance. It also does not include the contents of any block volumes that are attached to the instance.
               
               To create an instance configuration that includes the custom setup from an instance's boot volume, you must first create a custom image from the instance (see [CreateImage](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Image/CreateImage)). Then, use the custom image to launch a new instance (see [LaunchInstance](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstance)). Finally, create the instance configuration based on the instance that you created from the custom image.
               
               To include block volume contents with an instance configuration, first create a backup of the attached block volumes (see [CreateVolumeBackup](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/VolumeBackup/CreateVolumeBackup)). Then, create the instance configuration by specifying the list of settings, using [InstanceConfigurationVolumeSourceFromVolumeBackupDetails](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/datatypes/InstanceConfigurationVolumeSourceFromVolumeBackupDetails) to include the block volume backups in the list of settings.
               
               The following values are supported:
        :param pulumi.Input[str] time_created: The date and time the instance configuration was created, in the format defined by [RFC3339](https://tools.ietf.org/html/rfc3339).  Example: `2016-08-25T21:10:29.600Z`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InstanceConfigurationState.__new__(_InstanceConfigurationState)

        __props__.__dict__["compartment_id"] = compartment_id
        __props__.__dict__["deferred_fields"] = deferred_fields
        __props__.__dict__["defined_tags"] = defined_tags
        __props__.__dict__["display_name"] = display_name
        __props__.__dict__["freeform_tags"] = freeform_tags
        __props__.__dict__["instance_details"] = instance_details
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["source"] = source
        __props__.__dict__["time_created"] = time_created
        return InstanceConfiguration(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> pulumi.Output[str]:
        """
        (Updatable) The OCID of the compartment containing images to search
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="deferredFields")
    def deferred_fields(self) -> pulumi.Output[Sequence[str]]:
        """
        Parameters that were not specified when the instance configuration was created, but that are required to launch an instance from the instance configuration. See the [LaunchInstanceConfiguration](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstanceConfiguration) operation.
        """
        return pulumi.get(self, "deferred_fields")

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> pulumi.Output[Mapping[str, Any]]:
        """
        Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Output[str]:
        """
        A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> pulumi.Output[Mapping[str, Any]]:
        """
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @property
    @pulumi.getter(name="instanceDetails")
    def instance_details(self) -> pulumi.Output['outputs.InstanceConfigurationInstanceDetails']:
        return pulumi.get(self, "instance_details")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the instance to use to create the instance configuration.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def source(self) -> pulumi.Output[str]:
        """
        The source of the instance configuration. An instance configuration defines the settings to use when creating Compute instances, including details such as the base image, shape, and metadata. You can also specify the associated resources for the instance, such as block volume attachments and network configuration.

        When you create an instance configuration using an existing instance as a template, the instance configuration does not include any information from the source instance's boot volume, such as installed applications, binaries, and files on the instance. It also does not include the contents of any block volumes that are attached to the instance.

        To create an instance configuration that includes the custom setup from an instance's boot volume, you must first create a custom image from the instance (see [CreateImage](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Image/CreateImage)). Then, use the custom image to launch a new instance (see [LaunchInstance](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/Instance/LaunchInstance)). Finally, create the instance configuration based on the instance that you created from the custom image.

        To include block volume contents with an instance configuration, first create a backup of the attached block volumes (see [CreateVolumeBackup](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/VolumeBackup/CreateVolumeBackup)). Then, create the instance configuration by specifying the list of settings, using [InstanceConfigurationVolumeSourceFromVolumeBackupDetails](https://docs.cloud.oracle.com/iaas/api/#/en/iaas/latest/datatypes/InstanceConfigurationVolumeSourceFromVolumeBackupDetails) to include the block volume backups in the list of settings.

        The following values are supported:
        """
        return pulumi.get(self, "source")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> pulumi.Output[str]:
        """
        The date and time the instance configuration was created, in the format defined by [RFC3339](https://tools.ietf.org/html/rfc3339).  Example: `2016-08-25T21:10:29.600Z`
        """
        return pulumi.get(self, "time_created")

