# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetNotificationTopicsFilterResult',
    'GetNotificationTopicsNotificationTopicResult',
    'GetSubscriptionsFilterResult',
    'GetSubscriptionsSubscriptionResult',
    'GetSubscriptionsSubscriptionDeliveryPolicyResult',
    'GetSubscriptionsSubscriptionDeliveryPolicyBackoffRetryPolicyResult',
]

@pulumi.output_type
class GetNotificationTopicsFilterResult(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str],
                 regex: Optional[bool] = None):
        """
        :param str name: A filter to only return resources that match the given name exactly.
        """
        GetNotificationTopicsFilterResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            values=values,
            regex=regex,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: str,
             values: Sequence[str],
             regex: Optional[bool] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("name", name)
        _setter("values", values)
        if regex is not None:
            _setter("regex", regex)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        A filter to only return resources that match the given name exactly.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        return pulumi.get(self, "values")

    @property
    @pulumi.getter
    def regex(self) -> Optional[bool]:
        return pulumi.get(self, "regex")


@pulumi.output_type
class GetNotificationTopicsNotificationTopicResult(dict):
    def __init__(__self__, *,
                 api_endpoint: str,
                 compartment_id: str,
                 defined_tags: Mapping[str, Any],
                 description: str,
                 etag: str,
                 freeform_tags: Mapping[str, Any],
                 id: str,
                 name: str,
                 short_topic_id: str,
                 state: str,
                 time_created: str,
                 topic_id: str):
        """
        :param str api_endpoint: The endpoint for managing subscriptions or publishing messages to the topic.
        :param str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        :param Mapping[str, Any] defined_tags: Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param str description: The description of the topic.
        :param str etag: For optimistic concurrency control. See `if-match`.
        :param Mapping[str, Any] freeform_tags: Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        :param str id: A filter to only return resources that match the given id exactly.
        :param str name: A filter to only return resources that match the given name exactly.
        :param str short_topic_id: A unique short topic Id. This is used only for SMS subscriptions.
        :param str state: Filter returned list by specified lifecycle state. This parameter is case-insensitive.
        :param str time_created: The time the topic was created.
        :param str topic_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the topic.
        """
        GetNotificationTopicsNotificationTopicResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            api_endpoint=api_endpoint,
            compartment_id=compartment_id,
            defined_tags=defined_tags,
            description=description,
            etag=etag,
            freeform_tags=freeform_tags,
            id=id,
            name=name,
            short_topic_id=short_topic_id,
            state=state,
            time_created=time_created,
            topic_id=topic_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             api_endpoint: str,
             compartment_id: str,
             defined_tags: Mapping[str, Any],
             description: str,
             etag: str,
             freeform_tags: Mapping[str, Any],
             id: str,
             name: str,
             short_topic_id: str,
             state: str,
             time_created: str,
             topic_id: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'apiEndpoint' in kwargs:
            api_endpoint = kwargs['apiEndpoint']
        if 'compartmentId' in kwargs:
            compartment_id = kwargs['compartmentId']
        if 'definedTags' in kwargs:
            defined_tags = kwargs['definedTags']
        if 'freeformTags' in kwargs:
            freeform_tags = kwargs['freeformTags']
        if 'shortTopicId' in kwargs:
            short_topic_id = kwargs['shortTopicId']
        if 'timeCreated' in kwargs:
            time_created = kwargs['timeCreated']
        if 'topicId' in kwargs:
            topic_id = kwargs['topicId']

        _setter("api_endpoint", api_endpoint)
        _setter("compartment_id", compartment_id)
        _setter("defined_tags", defined_tags)
        _setter("description", description)
        _setter("etag", etag)
        _setter("freeform_tags", freeform_tags)
        _setter("id", id)
        _setter("name", name)
        _setter("short_topic_id", short_topic_id)
        _setter("state", state)
        _setter("time_created", time_created)
        _setter("topic_id", topic_id)

    @property
    @pulumi.getter(name="apiEndpoint")
    def api_endpoint(self) -> str:
        """
        The endpoint for managing subscriptions or publishing messages to the topic.
        """
        return pulumi.get(self, "api_endpoint")

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Mapping[str, Any]:
        """
        Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the topic.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def etag(self) -> str:
        """
        For optimistic concurrency control. See `if-match`.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Mapping[str, Any]:
        """
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        A filter to only return resources that match the given id exactly.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        A filter to only return resources that match the given name exactly.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="shortTopicId")
    def short_topic_id(self) -> str:
        """
        A unique short topic Id. This is used only for SMS subscriptions.
        """
        return pulumi.get(self, "short_topic_id")

    @property
    @pulumi.getter
    def state(self) -> str:
        """
        Filter returned list by specified lifecycle state. This parameter is case-insensitive.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> str:
        """
        The time the topic was created.
        """
        return pulumi.get(self, "time_created")

    @property
    @pulumi.getter(name="topicId")
    def topic_id(self) -> str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the topic.
        """
        return pulumi.get(self, "topic_id")


@pulumi.output_type
class GetSubscriptionsFilterResult(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str],
                 regex: Optional[bool] = None):
        GetSubscriptionsFilterResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            values=values,
            regex=regex,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: str,
             values: Sequence[str],
             regex: Optional[bool] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("name", name)
        _setter("values", values)
        if regex is not None:
            _setter("regex", regex)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        return pulumi.get(self, "values")

    @property
    @pulumi.getter
    def regex(self) -> Optional[bool]:
        return pulumi.get(self, "regex")


@pulumi.output_type
class GetSubscriptionsSubscriptionResult(dict):
    def __init__(__self__, *,
                 compartment_id: str,
                 created_time: str,
                 defined_tags: Mapping[str, Any],
                 delivery_policies: Sequence['outputs.GetSubscriptionsSubscriptionDeliveryPolicyResult'],
                 endpoint: str,
                 etag: str,
                 freeform_tags: Mapping[str, Any],
                 id: str,
                 protocol: str,
                 state: str,
                 topic_id: str):
        """
        :param str compartment_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        :param str created_time: The time when this suscription was created.
        :param Mapping[str, Any] defined_tags: Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        :param str endpoint: A locator that corresponds to the subscription protocol.  For example, an email address for a subscription that uses the `EMAIL` protocol, or a URL for a subscription that uses an HTTP-based protocol. Avoid entering confidential information.
        :param str etag: For optimistic concurrency control. See `if-match`.
        :param Mapping[str, Any] freeform_tags: Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        :param str id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the subscription.
        :param str protocol: The protocol used for the subscription.
        :param str state: The lifecycle state of the subscription. The status of a new subscription is PENDING; when confirmed, the subscription status changes to ACTIVE.
        :param str topic_id: Return all subscriptions that are subscribed to the given topic OCID. Either this query parameter or the compartmentId query parameter must be set.
        """
        GetSubscriptionsSubscriptionResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            compartment_id=compartment_id,
            created_time=created_time,
            defined_tags=defined_tags,
            delivery_policies=delivery_policies,
            endpoint=endpoint,
            etag=etag,
            freeform_tags=freeform_tags,
            id=id,
            protocol=protocol,
            state=state,
            topic_id=topic_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             compartment_id: str,
             created_time: str,
             defined_tags: Mapping[str, Any],
             delivery_policies: Sequence['outputs.GetSubscriptionsSubscriptionDeliveryPolicyResult'],
             endpoint: str,
             etag: str,
             freeform_tags: Mapping[str, Any],
             id: str,
             protocol: str,
             state: str,
             topic_id: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'compartmentId' in kwargs:
            compartment_id = kwargs['compartmentId']
        if 'createdTime' in kwargs:
            created_time = kwargs['createdTime']
        if 'definedTags' in kwargs:
            defined_tags = kwargs['definedTags']
        if 'deliveryPolicies' in kwargs:
            delivery_policies = kwargs['deliveryPolicies']
        if 'freeformTags' in kwargs:
            freeform_tags = kwargs['freeformTags']
        if 'topicId' in kwargs:
            topic_id = kwargs['topicId']

        _setter("compartment_id", compartment_id)
        _setter("created_time", created_time)
        _setter("defined_tags", defined_tags)
        _setter("delivery_policies", delivery_policies)
        _setter("endpoint", endpoint)
        _setter("etag", etag)
        _setter("freeform_tags", freeform_tags)
        _setter("id", id)
        _setter("protocol", protocol)
        _setter("state", state)
        _setter("topic_id", topic_id)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> str:
        """
        The time when this suscription was created.
        """
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter(name="definedTags")
    def defined_tags(self) -> Mapping[str, Any]:
        """
        Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Operations.CostCenter": "42"}`
        """
        return pulumi.get(self, "defined_tags")

    @property
    @pulumi.getter(name="deliveryPolicies")
    def delivery_policies(self) -> Sequence['outputs.GetSubscriptionsSubscriptionDeliveryPolicyResult']:
        return pulumi.get(self, "delivery_policies")

    @property
    @pulumi.getter
    def endpoint(self) -> str:
        """
        A locator that corresponds to the subscription protocol.  For example, an email address for a subscription that uses the `EMAIL` protocol, or a URL for a subscription that uses an HTTP-based protocol. Avoid entering confidential information.
        """
        return pulumi.get(self, "endpoint")

    @property
    @pulumi.getter
    def etag(self) -> str:
        """
        For optimistic concurrency control. See `if-match`.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter(name="freeformTags")
    def freeform_tags(self) -> Mapping[str, Any]:
        """
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).  Example: `{"Department": "Finance"}`
        """
        return pulumi.get(self, "freeform_tags")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the subscription.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def protocol(self) -> str:
        """
        The protocol used for the subscription.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter
    def state(self) -> str:
        """
        The lifecycle state of the subscription. The status of a new subscription is PENDING; when confirmed, the subscription status changes to ACTIVE.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter(name="topicId")
    def topic_id(self) -> str:
        """
        Return all subscriptions that are subscribed to the given topic OCID. Either this query parameter or the compartmentId query parameter must be set.
        """
        return pulumi.get(self, "topic_id")


@pulumi.output_type
class GetSubscriptionsSubscriptionDeliveryPolicyResult(dict):
    def __init__(__self__, *,
                 backoff_retry_policies: Sequence['outputs.GetSubscriptionsSubscriptionDeliveryPolicyBackoffRetryPolicyResult']):
        GetSubscriptionsSubscriptionDeliveryPolicyResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            backoff_retry_policies=backoff_retry_policies,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             backoff_retry_policies: Sequence['outputs.GetSubscriptionsSubscriptionDeliveryPolicyBackoffRetryPolicyResult'],
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'backoffRetryPolicies' in kwargs:
            backoff_retry_policies = kwargs['backoffRetryPolicies']

        _setter("backoff_retry_policies", backoff_retry_policies)

    @property
    @pulumi.getter(name="backoffRetryPolicies")
    def backoff_retry_policies(self) -> Sequence['outputs.GetSubscriptionsSubscriptionDeliveryPolicyBackoffRetryPolicyResult']:
        return pulumi.get(self, "backoff_retry_policies")


@pulumi.output_type
class GetSubscriptionsSubscriptionDeliveryPolicyBackoffRetryPolicyResult(dict):
    def __init__(__self__, *,
                 max_retry_duration: int,
                 policy_type: str):
        """
        :param int max_retry_duration: The maximum retry duration in milliseconds.
        :param str policy_type: The type of delivery policy. Default value: EXPONENTIAL.
        """
        GetSubscriptionsSubscriptionDeliveryPolicyBackoffRetryPolicyResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            max_retry_duration=max_retry_duration,
            policy_type=policy_type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             max_retry_duration: int,
             policy_type: str,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'maxRetryDuration' in kwargs:
            max_retry_duration = kwargs['maxRetryDuration']
        if 'policyType' in kwargs:
            policy_type = kwargs['policyType']

        _setter("max_retry_duration", max_retry_duration)
        _setter("policy_type", policy_type)

    @property
    @pulumi.getter(name="maxRetryDuration")
    def max_retry_duration(self) -> int:
        """
        The maximum retry duration in milliseconds.
        """
        return pulumi.get(self, "max_retry_duration")

    @property
    @pulumi.getter(name="policyType")
    def policy_type(self) -> str:
        """
        The type of delivery policy. Default value: EXPONENTIAL.
        """
        return pulumi.get(self, "policy_type")


