# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'AppAccelerationPolicyResponseCachingPolicyArgs',
    'AppAccelerationPolicyResponseCompressionPolicyArgs',
    'AppAccelerationPolicyResponseCompressionPolicyGzipCompressionArgs',
    'GetAppAccelerationPoliciesFilterArgs',
    'GetAppAccelerationsFilterArgs',
]

@pulumi.input_type
class AppAccelerationPolicyResponseCachingPolicyArgs:
    def __init__(__self__, *,
                 is_response_header_based_caching_enabled: Optional[pulumi.Input[bool]] = None):
        """
        :param pulumi.Input[bool] is_response_header_based_caching_enabled: (Updatable) When false, responses will not be cached by the backend based on response headers.
               
               When true, responses that contain one of the supported cache control headers will be cached according to the values specified in the cache control headers.
               
               The "X-Accel-Expires" header field sets caching time of a response in seconds. The zero value disables caching for a response. If the value starts with the @ prefix, it sets an absolute time in seconds since Epoch, up to which the response may be cached.
               
               If the header does not include the "X-Accel-Expires" field, parameters of caching may be set in the header fields "Expires" or "Cache-Control".
               
               If the header includes the "Set-Cookie" field, such a response will not be cached.
               
               If the header includes the "Vary" field with the special value "*", such a response will not be cached. If the header includes the "Vary" field with another value, such a response will be cached taking into account the corresponding request header fields.
        """
        AppAccelerationPolicyResponseCachingPolicyArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            is_response_header_based_caching_enabled=is_response_header_based_caching_enabled,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             is_response_header_based_caching_enabled: Optional[pulumi.Input[bool]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'isResponseHeaderBasedCachingEnabled' in kwargs:
            is_response_header_based_caching_enabled = kwargs['isResponseHeaderBasedCachingEnabled']

        if is_response_header_based_caching_enabled is not None:
            _setter("is_response_header_based_caching_enabled", is_response_header_based_caching_enabled)

    @property
    @pulumi.getter(name="isResponseHeaderBasedCachingEnabled")
    def is_response_header_based_caching_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        (Updatable) When false, responses will not be cached by the backend based on response headers.

        When true, responses that contain one of the supported cache control headers will be cached according to the values specified in the cache control headers.

        The "X-Accel-Expires" header field sets caching time of a response in seconds. The zero value disables caching for a response. If the value starts with the @ prefix, it sets an absolute time in seconds since Epoch, up to which the response may be cached.

        If the header does not include the "X-Accel-Expires" field, parameters of caching may be set in the header fields "Expires" or "Cache-Control".

        If the header includes the "Set-Cookie" field, such a response will not be cached.

        If the header includes the "Vary" field with the special value "*", such a response will not be cached. If the header includes the "Vary" field with another value, such a response will be cached taking into account the corresponding request header fields.
        """
        return pulumi.get(self, "is_response_header_based_caching_enabled")

    @is_response_header_based_caching_enabled.setter
    def is_response_header_based_caching_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_response_header_based_caching_enabled", value)


@pulumi.input_type
class AppAccelerationPolicyResponseCompressionPolicyArgs:
    def __init__(__self__, *,
                 gzip_compression: Optional[pulumi.Input['AppAccelerationPolicyResponseCompressionPolicyGzipCompressionArgs']] = None):
        """
        :param pulumi.Input['AppAccelerationPolicyResponseCompressionPolicyGzipCompressionArgs'] gzip_compression: (Updatable) An object that specifies the gzip compression policy.
        """
        AppAccelerationPolicyResponseCompressionPolicyArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            gzip_compression=gzip_compression,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             gzip_compression: Optional[pulumi.Input['AppAccelerationPolicyResponseCompressionPolicyGzipCompressionArgs']] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'gzipCompression' in kwargs:
            gzip_compression = kwargs['gzipCompression']

        if gzip_compression is not None:
            _setter("gzip_compression", gzip_compression)

    @property
    @pulumi.getter(name="gzipCompression")
    def gzip_compression(self) -> Optional[pulumi.Input['AppAccelerationPolicyResponseCompressionPolicyGzipCompressionArgs']]:
        """
        (Updatable) An object that specifies the gzip compression policy.
        """
        return pulumi.get(self, "gzip_compression")

    @gzip_compression.setter
    def gzip_compression(self, value: Optional[pulumi.Input['AppAccelerationPolicyResponseCompressionPolicyGzipCompressionArgs']]):
        pulumi.set(self, "gzip_compression", value)


@pulumi.input_type
class AppAccelerationPolicyResponseCompressionPolicyGzipCompressionArgs:
    def __init__(__self__, *,
                 is_enabled: Optional[pulumi.Input[bool]] = None):
        """
        :param pulumi.Input[bool] is_enabled: (Updatable) When true, support for gzip compression is enabled. HTTP responses will be compressed with gzip only if the client indicates support for gzip via the "Accept-Encoding: gzip" request header.
               
               When false, support for gzip compression is disabled and HTTP responses will not be compressed with gzip even if the client indicates support for gzip.
        """
        AppAccelerationPolicyResponseCompressionPolicyGzipCompressionArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            is_enabled=is_enabled,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             is_enabled: Optional[pulumi.Input[bool]] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):
        if 'isEnabled' in kwargs:
            is_enabled = kwargs['isEnabled']

        if is_enabled is not None:
            _setter("is_enabled", is_enabled)

    @property
    @pulumi.getter(name="isEnabled")
    def is_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        (Updatable) When true, support for gzip compression is enabled. HTTP responses will be compressed with gzip only if the client indicates support for gzip via the "Accept-Encoding: gzip" request header.

        When false, support for gzip compression is disabled and HTTP responses will not be compressed with gzip even if the client indicates support for gzip.
        """
        return pulumi.get(self, "is_enabled")

    @is_enabled.setter
    def is_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_enabled", value)


@pulumi.input_type
class GetAppAccelerationPoliciesFilterArgs:
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str],
                 regex: Optional[bool] = None):
        GetAppAccelerationPoliciesFilterArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            values=values,
            regex=regex,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: str,
             values: Sequence[str],
             regex: Optional[bool] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("name", name)
        _setter("values", values)
        if regex is not None:
            _setter("regex", regex)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: str):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: Sequence[str]):
        pulumi.set(self, "values", value)

    @property
    @pulumi.getter
    def regex(self) -> Optional[bool]:
        return pulumi.get(self, "regex")

    @regex.setter
    def regex(self, value: Optional[bool]):
        pulumi.set(self, "regex", value)


@pulumi.input_type
class GetAppAccelerationsFilterArgs:
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str],
                 regex: Optional[bool] = None):
        GetAppAccelerationsFilterArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            values=values,
            regex=regex,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: str,
             values: Sequence[str],
             regex: Optional[bool] = None,
             opts: Optional[pulumi.ResourceOptions]=None,
             **kwargs):

        _setter("name", name)
        _setter("values", values)
        if regex is not None:
            _setter("regex", regex)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: str):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: Sequence[str]):
        pulumi.set(self, "values", value)

    @property
    @pulumi.getter
    def regex(self) -> Optional[bool]:
        return pulumi.get(self, "regex")

    @regex.setter
    def regex(self, value: Optional[bool]):
        pulumi.set(self, "regex", value)


